#!/usr/bin/env python
# coding: utf-8
# $Id$
# 指定された時間、Rをマスクするクラス
import re
class Mask(object):
    def __init__(self):
        self.avgnum = 1
        self.ntmask = []
        self.nrmask = []
        self.rmask = []
        self.tmask = []
        self.bmask = False
        
    def check_in_range(self, val, l):
        for e in l:
            if ( e[0] <= val <= e[1]):
                return True
        return False
            
    def parse_option_single(self, fmt, option):
        ntmask = []
        m = re.match(fmt, option)
        if m:
            for si in m.groups()[0].split(','):
                try:
                    idx = int(si)
                    ntmask.append(idx)
                except:
                    pass
            return ntmask
        return False
    
    def parse_option(self, option):
        if not option:
            return 

        _avgnum = self.parse_option_single(r'ntavg\s*=\s*([0-9]+)', option)
        _ntmask = self.parse_option_single(r'ntmask\s*=\s*(\d+(\s*,\s*\d+)*)',option)
        _nrmask = self.parse_option_single(r'nrmask\s*=\s*(\d+(\s*,\s*\d+)*)',option)
        self.bmask = bool(re.match(r'.*(bmask).*',option))

        if _avgnum:
            n = _avgnum[0]
            #self.avgnum = n if n>0 and n<=20 else 1
            self.avgnum = n
        if _ntmask:
            self.ntmask = _ntmask
        if _nrmask:
            self.nrmask = _nrmask

        m = re.search(r'tmask\s*=\s*([^,]+(,[^,]+)*)',option)
        if m:
            args = m.groups()[0]
            l=args.split(',')
            for e in l:
                l2 = e.split('~')
                if ( len(l2) == 2 ):
                    self.tmask.append([float(l2[0]),float(l2[1])])
        m = re.search(r'rmask\s*=\s*([^,]+(,[^,]+)*)',option)
        if m:
            args = m.groups()[0]
            l=args.split(',')
            for e in l:
                l2 = e.split('~')
                if ( len(l2) == 2 ):
                    self.rmask.append([float(l2[0]),float(l2[1])])

    def masked_t(self, tlist):
        ret = []
        for tidx, t in enumerate(tlist):
            if tidx in self.ntmask:
                continue
            if self.check_in_range(t, self.tmask):
                continue
            ret.append((tidx, t))
        return ret
    
    def masked_r(self, rlist):
        ret = []
        for ridx, r in enumerate(rlist):
            if ridx in self.nrmask:
                continue
            if self.check_in_range(r, self.rmask):
                continue
            ret.append((ridx, r))
        return ret

                   
