#!/usr/bin/env python
# coding: utf-8
# $Id$

import wx
from MyViewColorPicker import *

if wx.__version__ < '3.0':
    wx.Colour = wx.Color

def EmptyBitmap(w, h):
    if wx.__version__ < '4.0':
        return wx.EmptyBitmap(w, h)
    return wx.Bitmap(w, h)

class ColorButton(wx.BitmapButton):
    def __init__(self, parent, color, colorpicker=None):
        if colorpicker is not None:
            self.colorpicker = colorpicker
        else:
            self.colorpicker = ColorPicker()

        self.color = color
        bmp = self.MakeBitmap(self.color)
        wx.BitmapButton.__init__(self, parent, -1, bmp)
        self.Bind(wx.EVT_BUTTON, self.OnButton, self)
  
    def get_color(self):
        return self.color

    def set_color(self, color):
        self.color = color
        bmp = self.MakeBitmap(self.color)
        self.SetBitmapLabel(bmp)

    def MakeBitmap(self, color):
        #bmp = wx.EmptyBitmap(200, 15)
        bmp = wx.Bitmap(200, 15)
        dc = wx.MemoryDC()
        dc.SelectObject(bmp)
        dc.SetBackground(wx.Brush(color))
        dc.Clear()
        dc.SelectObject(wx.NullBitmap)
        return bmp 

    def OnButton(self, event):
        col = self.colorpicker.askUser(self, self.color)
        if col:
            self.set_color(col)




