#!/usr/bin/env python
# coding: utf-8
# $Id$

import wx
import os
from MyViewGraphInfo import *

try:
    _dummy = wx.Colour
except NameError:
    wx.Colour = wx.Color

class SetStaticLabelDlg(wx.Dialog):
    """
    スタティックラベル設定用ダイアログ
    """
    def __init__(self, parent, defaultpath=None):
        wx.Dialog.__init__(self, parent, -1, 'MyView2 Convert Layout file', 
                style=wx.DEFAULT_DIALOG_STYLE)
       
        #self.SetBackgroundColour(wx.Colour(200, 200, 200))
        self.font = wx.Font(11, wx.MODERN, wx.NORMAL, wx.NORMAL, False)

        self.defaultpath = defaultpath

        stTarget = wx.StaticText(self, -1, "Target Folder: ")
        self.tcTarget = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER, size=(400, 20))
        self.btnTarget = wx.Button(self, -1, 'F')
       
        fgsizer = wx.FlexGridSizer(rows=1, cols=3, hgap=5, vgap=5)
        fgsizer.AddGrowableCol(1)
        fgsizer.Add(stTarget, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.tcTarget, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.btnTarget, 0, wx.ALIGN_CENTER_VERTICAL)

        btnOk = wx.Button(self, wx.ID_OK, "Convert")
        btnOk.SetDefault()
        btnCancel= wx.Button(self, wx.ID_CANCEL, "Cancel")
        btnsizer = wx.BoxSizer(wx.HORIZONTAL)
        btnsizer.Add((20, 20), 3, wx.EXPAND)
        btnsizer.Add(btnOk, 1, wx.ALIGN_RIGHT)
        btnsizer.Add((20, 20), 0, wx.ALL)
        btnsizer.Add(btnCancel, 1, wx.ALIGN_RIGHT)
        
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(fgsizer, 0, wx.EXPAND|wx.ALL)
        sizer.Add(btnsizer, 0, wx.EXPAND|wx.ALL, 5)
        
        self.SetSizer(sizer)
        self.Fit()

        self.Bind(wx.EVT_BUTTON, self.OnFolderSelect, self.btnTarget)

        self.SetStateFirst()

    def SetStateFirst(self):
        """
        Setup the value of widgets on this dialog 
        """
        if self.defaultpath:
            self.tcTarget.SetValue("%s" % self.defaultpath)
        else:
            self.tcTarget.SetValue("%s" % "")


    def OnFolderSelect(self, event=None):
        tc = self.tcTarget

        path = tc.GetValue()
        default = os.path.join(os.getcwd(), path)
        dialog = wx.DirDialog(self, "Select Folder", default,  
                style=wx.DD_DEFAULT_STYLE)
        if dialog.ShowModal() == wx.ID_OK:
            selectpath = dialog.GetPath()
            tc.SetValue("%s" % selectpath)
        dialog.Destroy()

    def GetResult(self):
        """
        設定した内容を配列で返す
        """
        return self.tcTarget.GetValue()

    def OnQuit(self, evt=None):
        self.Close()

def ConvertLayout(parent, defaultpath=None):
    dialog = SetStaticLabelDlg(parent, defaultpath)
    result = dialog.ShowModal()
    if result == wx.ID_OK:
        dialogdata = dialog.GetResult()
        cmdpath = os.path.join("tools", "conv_layout.py")
        cmd = '%s "%s"' % (cmdpath, dialogdata)
        os.system(cmd)

    dialog.Destroy()

if __name__ == '__main__':
    app = wx.App()
    ConvertLayout(None, "user/layout")



