#!/usr/bin/env python
# coding: utf-8
# $Id$

import platform
import os
import sys

class MyViewEnv():
    """
    OS 毎の環境をセットアップするクラス
    """
    def __init__(self):
        self.encoding = sys.getfilesystemencoding()
        #print self.encoding
        self.system = platform.system()
        self.oldpath = os.environ['PATH']
        #self.oldlpath = self.oldpath.decode(self.encoding)
        if ( self.system == "Windows" ):
            self.printcmd='lpr -S %s -P %s %s'
            self.dirsep = '\\'
        elif (self.system == "Linux" ):
            lpath=os.getenv('LD_LIBRARY_PATH')
            if ( lpath is None ):
                lpath = ''
            self.oldlpath = lpath
            self.printcmd='lpr -H %s -P %s %s'
            self.dirsep = '/'
        elif ( self.system == "Darwin"):
            lpath=os.getenv('DYLD_LIBRARY_PATH')
            if ( lpath is None ):
                lpath = ''
            self.oldlpath = lpath
            self.printcmd='lpr -H %s -P %s %s'
            self.dirsep = '/'

        os.environ['CLIENT_INI2']='client2.ini'
        os.environ['INDEXSERVERNAME']= 'dasindex.lhd.nifs.ac.jp'

    def addPath(self, path):
        if ( self.system == "Windows" ):
            npath = os.path.join(path, 'win')
            #npath = npath.encode(self.encoding)
            os.environ['PATH'] = npath + ';' + self.oldpath
        elif ( self.system == "Linux" ):
            npath = os.path.join(path, 'linux')
            #npath = npath.encode(self.encoding)
            os.environ['PATH'] = npath + ':' + self.oldpath
            os.environ['LD_LIBRARY_PATH'] = npath + ':' + self.oldlpath
        elif ( self.system == "Darwin" ):
            npath = os.path.join(path, 'mac')
            #npath = npath.encode(self.encoding)
            os.environ['PATH'] = npath + ':' + self.oldpath
            os.environ['DYLD_LIBRARY_PATH'] = npath + ':' + self.oldlpath

    def set(self, key, val):
        os.environ[key]=val

Runtime = MyViewEnv()

if __name__ == '__main__':
    print((Runtime.system))
    print((Runtime.oldpath))
    print((Runtime.oldlpath))
    Runtime.addPath('bin')
    print((os.environ['PATH']))
    print((os.environ['DYLD_LIBRARY_PATH']))

