#!/usr/bin/env python
# coding: utf-8
# $Id$

import wx
import wx.lib.newevent
import os
#if wx.__version__ < '3.0':
try:
    _dummy = wx.Colour
except NameError:
    wx.Colour = wx.Color


class GetBatchFromToDlg(wx.Dialog):
    def __init__(self, parent, dataid):
        wx.Dialog.__init__(self, parent, -1, 'MyView Batch Control', 
                style=wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER)

        self.dataid = dataid

        stDataID = wx.StaticText(self, -1, "Data ID(s): ")
        stExample = wx.StaticText(self, -1, "(Example) 1-10, 13, 17")
        stPNG = wx.StaticText(self, -1, "Create PNG ")
        stPrint = wx.StaticText(self, -1, "Print ")
        stExport = wx.StaticText(self, -1, "Export ")

        self.tcShots = wx.TextCtrl(self, -1, '', size=(400, 20))
        self.cbPNG =  wx.CheckBox(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.cbPrint = wx.CheckBox(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.cbExport = wx.CheckBox(self, -1, '', style=wx.TE_PROCESS_ENTER)

#        fgsizer = wx.FlexGridSizer(rows=3, cols=9, hgap=5, vgap=5)

        shotsizer = wx.BoxSizer(wx.HORIZONTAL)
        shotsizer.Add(stDataID)
        shotsizer.Add(self.tcShots)

        chksizer = wx.BoxSizer(wx.HORIZONTAL)
        chksizer.Add(stPNG)
        chksizer.Add(self.cbPNG)
        chksizer.Add(stPrint)
        chksizer.Add(self.cbPrint)
        chksizer.Add(stExport)
        chksizer.Add(self.cbExport)

        self.okButton = wx.Button(self, wx.ID_OK, "OK")
        self.cancelButton = wx.Button(self, wx.ID_CANCEL, "Cancel")
        btnsizer = wx.BoxSizer(wx.HORIZONTAL)
        btnsizer.Add(self.okButton, 1, wx.EXPAND)
        btnsizer.Add(self.cancelButton, 1, wx.EXPAND)
        
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(shotsizer, 0, wx.EXPAND|wx.ALL)
        sizer.Add(stExample, 0, wx.ALIGN_RIGHT)
        sizer.Add(chksizer, 0, wx.EXPAND|wx.ALL)
        sizer.Add(btnsizer, 0, wx.EXPAND|wx.ALL, 5)
        self.SetSizer(sizer)
        self.Fit()

        self.SetStateFirst()

    def SetStateFirst(self):
        self.tcShots.SetValue("%s-%s" % (self.dataid,self.dataid, ))

    def GetResult(self):
        """
        設定した内容を配列で返す
        """
        return (self.tcShots.GetValue(), self.cbPNG.GetValue(), self.cbPrint.GetValue(), self.cbExport.GetValue())


if __name__ == '__main__':
    app = wx.App()

    dialog = GetBatchFromToDlg(None, '106362')
    result = dialog.ShowModal()
    if result == wx.ID_OK:
        print((dialog.GetResult()))
    dialog.Destroy()

