#!/usr/bin/env python
# coding: utf-8
# $Id$
from __future__ import print_function
import os


class Presets():
    """
    プリセットを管理するクラス
    """
    def __init__(self, **args):
        self.ClearInstances()

    def PresetLoad(self, filepath):
        self.ClearInstances()

        if ( not os.path.exists(filepath)):
            return
        with open(filepath) as f:
            lines = f.readlines()
        for line in lines:
            l = line.strip('\n')
            if 0 == len(l): continue
            if l[0] == '#': continue
            f = l.split('\t')
            if ( len(f) == 2 ):
                self.dict_presets[f[0]] = f[1]
            elif ( len(f) == 1 ):
                self.dict_presets[f[0]] =''

    def ClearInstances(self):
        self.dict_presets = {}
    
    def GetDict(self):
        return self.dict_presets
        
if __name__ == '__main__':
    presets = Presets()
    presets.PresetLoad('./Presets/presets.txt')
    dict = presets.GetDict()
    print(dict)

