#!/usr/bin/env python
# coding:utf-8

import os
import json
import sys
import shutil

#PROFILES_DIR=os.path.join(os.path.dirname(__file__),'profiles')
PROFILES_DIR='profiles'

class Profile:
    def __init__(self):
        with open(os.path.join(PROFILES_DIR,"profiles.json")) as f:
            self.PROFILES = json.load(f)

    def update(self, target):
        if target in self.PROFILES:
            profile = self.PROFILES[target]
        else:
            raise Exception("profile:%s is not registered" % (target))
            
        with open('client2.ini', 'w') as f:
            with open(os.path.join(PROFILES_DIR,profile['inifile'])) as ini:
                content  = ini.read()
                f.write(content.replace("\r",""))
        shutil.copy(os.path.join(PROFILES_DIR, profile['config']), "myView2.cnf")
        shutil.copy(os.path.join(PROFILES_DIR, profile['default']), "plot_default.txt")
        shutil.copy(os.path.join(PROFILES_DIR, profile['modules']), os.path.join("DataModules","datamodules.txt"))
        shutil.copy(os.path.join(PROFILES_DIR, profile['eglist']), "eglist.txt")


    def list(self):
        return self.PROFILES.keys()

if __name__ == '__main__':
    target = sys.argv[1]
    profile = Profile()
    #targets = profile.list()
    #print(targets)
    profile.update(target)
