#!/usr/bin/env python
# coding: utf-8
# $Id$

import wx
import wx.html
import os
import sys
from MyViewGraphInfo import *
from MyViewDataInfo import *
from MyViewColorButton import *

try:
    _dummy = wx.Colour
except NameError:
    wx.Colour = wx.Color

DefaultText = """
<p>Here is an expanation of this module <p><br>
Module name : modulename <br>
Script name : script.py <br>
Author name : the name of developer <br>
Contact to  : eg-support@nifs.ac.jp <br>
<br>
<p>Argument<p><br>
"""


class HtmlWindow(wx.html.HtmlWindow):
    def __init__(self, parent, id, size=(600,400)):
        wx.html.HtmlWindow.__init__(self,parent, id, size=size)
        if "gtk2" in wx.PlatformInfo:
            self.SetStandardFonts()

    def OnLinkClicked(self, link):
        wx.LaunchDefaultBrowser(link.GetHref())

class AboutBox(wx.Dialog):
    def __init__(self, parent, htmltext):
        wx.Dialog.__init__(self, parent, -1, "About modulename",
            style=wx.DEFAULT_DIALOG_STYLE|wx.THICK_FRAME|wx.RESIZE_BORDER|
                wx.TAB_TRAVERSAL)
        hwin = HtmlWindow(self, -1, size=(400,200))
        hwin.SetPage(htmltext)
        btn = hwin.FindWindowById(wx.ID_OK)
        irep = hwin.GetInternalRepresentation()
        hwin.SetSize((irep.GetWidth()+25, irep.GetHeight()+10))
        self.SetClientSize(hwin.GetSize())
        self.CentreOnParent(wx.BOTH)
        self.SetFocus()

class SetActiveLabelDlg(wx.Dialog):
    """
    アクティブラベルの設定クラス
    """
    def __init__(self, parent, alabel=None, graphinfo=None, datainfo=None, colorpicker=None):
        wx.Dialog.__init__(self, parent, -1, 'MyView2 Setup Active Label', 
                style=wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER)
        
        #self.SetBackgroundColour(wx.Colour(200, 200, 200))
        self.font = wx.Font(11, wx.MODERN, wx.NORMAL, wx.NORMAL, False)

        self.alabel = alabel
        self.label = alabel.label
        self.graphinfo = graphinfo
        self.datainfo = datainfo
        self.colorpicker = colorpicker
        """
        do not change the values in self.panel and self.graphinfo inside this dialog
        after back to parent, the values in the panel should be changed if the dialog 
        return the wx.ID_OK.
        You can get the values in this dialog with calling dialog.getResult()  
        """

        stPositionX = wx.StaticText(self, -1, "Position X: ")
        stPositionY = wx.StaticText(self, -1, "Position Y: ")
        self.btnModuleName = wx.Button(self, -1, "Module: ")
        stDataID = wx.StaticText(self, -1, "Data ID:")
        stArg = wx.StaticText(self, -1, "Arg: ")
        stFamily = wx.StaticText(self, -1, "Family: ")
        stStyle = wx.StaticText(self, -1, "Style: ")
        stWeight = wx.StaticText(self, -1, "Weight: ")
        stSize = wx.StaticText(self, -1, "Size: ")
        stColor = wx.StaticText(self, -1, "Color: ")
        stRotation = wx.StaticText(self, -1, "Rotation: ")
        stHAlign = wx.StaticText(self, -1, "HAlign: ")
        stVAlign = wx.StaticText(self, -1, "VAlign: ")

        self.btnPositionX = wx.Button(self, -1, 'Set')
        self.btnPositionY = wx.Button(self, -1, 'Set')

        radiopanel = wx.Panel(self, -1)
        self.radioIDC = wx.RadioButton(radiopanel, -1, "C", style=wx.RB_GROUP)
        self.radioIDR = wx.RadioButton(radiopanel, -1, "R") 
        self.radioIDA = wx.RadioButton(radiopanel, -1, "Any")
        self.tcIDA = wx.TextCtrl(radiopanel, -1, '', style=wx.TE_PROCESS_ENTER)
        self.btnIDA = wx.Button(radiopanel, -1, 'F')
        radiosizer = wx.BoxSizer(wx.HORIZONTAL)
        radiosizer.Add(self.radioIDC, 0, wx.ALL, 5)
        radiosizer.Add(self.radioIDR, 0, wx.ALL, 5)
        radiosizer.Add(self.radioIDA, 0, wx.ALL, 5)
        radiosizer.Add(self.tcIDA, 1, wx.EXPAND|wx.ALL, 5)
        radiosizer.Add(self.btnIDA, 0, wx.ALL, 5)
        radiopanel.SetSizer(radiosizer)
        radiopanel.Fit()

        self.tcPositionX = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcPositionY = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.choiceModuleName = wx.Choice(self, -1, choices=[])
        #self.tcText = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcArg = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.choiceFamily = wx.Choice(self, -1, choices=[])
        self.choiceStyle = wx.Choice(self, -1, choices=[])
        self.choiceWeight = wx.Choice(self, -1, choices=[])
        self.comboSize = wx.ComboBox(self, -1, choices=[])
        self.comboRotation = wx.ComboBox(self, -1, choices=[])
        self.choiceHAlign = wx.Choice(self, -1, choices=[])
        self.choiceVAlign = wx.Choice(self, -1, choices=[])
        color = "#%02X%02X%02X" % (255, 0, 0)
        self.btnColor = ColorButton(self, color, self.colorpicker)
       
        fgsizerPos = wx.FlexGridSizer(rows=2, cols=3, hgap=5, vgap=5)
        fgsizerPos.AddGrowableCol(1)
        fgsizerPos.Add(stPositionX, 0, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerPos.Add(self.tcPositionX, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerPos.Add(self.btnPositionX, 0, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerPos.Add(stPositionY, 0, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerPos.Add(self.tcPositionY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerPos.Add(self.btnPositionY, 0, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        fgsizer = wx.FlexGridSizer(rows=11, cols=2, hgap=5, vgap=5)
        fgsizer.AddGrowableCol(1)
        fgsizer.Add(self.btnModuleName, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.choiceModuleName, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stDataID, 0, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(radiopanel, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stArg, 0, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.tcArg, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stFamily, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.choiceFamily, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stStyle, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.choiceStyle, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stWeight, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.choiceWeight, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stSize, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.comboSize, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stColor, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.btnColor, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stRotation, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.comboRotation, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stHAlign, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.choiceHAlign, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stVAlign, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.choiceVAlign, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        btnOk = wx.Button(self, wx.ID_OK, "OK")
        btnOk.SetDefault()
        btnCancel= wx.Button(self, wx.ID_CANCEL, "Cancel")
        btnsizer = wx.BoxSizer(wx.HORIZONTAL)
        btnsizer.Add(btnOk, 1, wx.EXPAND)
        btnsizer.Add(btnCancel, 1, wx.EXPAND)
        
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(fgsizerPos, 0, wx.EXPAND|wx.ALL,5)
        sizer.Add(fgsizer, 0, wx.EXPAND|wx.ALL)
        sizer.Add(btnsizer, 0, wx.EXPAND|wx.ALL, 5)
        
        self.SetSizer(sizer)
        self.Fit()

        self.Bind(wx.EVT_BUTTON, self.OnModuleName, self.btnModuleName)
        self.Bind(wx.EVT_BUTTON, self.OnPositionX, self.btnPositionX)
        self.Bind(wx.EVT_BUTTON, self.OnPositionY, self.btnPositionY)
        self.Bind(wx.EVT_BUTTON, self.OnIDA, self.btnIDA)
        self.Bind(wx.EVT_SIZE, self.OnResize, self)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioButton, self.radioIDC)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioButton, self.radioIDR)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioButton, self.radioIDA)
        
        self.SetStateFirst()

    def SetStateFirst(self):
        """
        Setup the value of widgets on this dialog 
        by referencing with self.group and self.graphinfo.
        """
        posx = self.alabel.posx
        posy = self.alabel.posy
        self.tcPositionX.SetValue("%g" % posx)
        self.tcPositionY.SetValue("%g" % posy)
        choices = self.datainfo.getLabelModuleChoices()
        self.choiceModuleName.SetItems(choices)
        modulename = self.alabel.modulename
        if modulename in choices:
            self.choiceModuleName.SetSelection(choices.index(modulename))

        dataidc = self.alabel.dataidc
        if 'C' == dataidc.upper():
            self.radioIDC.SetValue(True)
            self.tcIDA.Enable(False)
            self.btnIDA.Enable(False)
        elif 'R' == dataidc.upper():
            self.radioIDR.SetValue(True)
            self.tcIDA.Enable(False)
            self.btnIDA.Enable(False)
        else:
            self.radioIDA.SetValue(True)
            self.tcIDA.Enable(True)
            self.btnIDA.Enable(True)
            self.tcIDA.SetValue("%s" % dataidc)

        #---------------------
        arg = self.alabel.arg
        self.tcArg.SetValue("%s" % arg)
        #---------------------
        choices = FontFamilySet
        self.choiceFamily.SetItems(choices)
        family = self.label.fontfamily
        if family in choices:
            idx = choices.index(family)
            self.choiceFamily.SetSelection(idx)
        #---------------------
        choices = FontStyleSet
        self.choiceStyle.SetItems(choices)
        style = self.label.fontstyle
        if style in choices:
            idx = choices.index(style)
            self.choiceStyle.SetSelection(idx)
        #---------------------
        choices = FontWeightSet
        self.choiceWeight.SetItems(choices)
        weight = self.label.fontweight
        if weight in choices:
            idx = choices.index(weight)
            self.choiceWeight.SetSelection(idx)
        #---------------------
        choices = FontSizeSet
        self.comboSize.SetItems(choices)
        self.comboSize.SetValue(self.label.fontsize)
        #---------------------
        choices = RotationSet
        self.comboRotation.SetItems(choices)
        self.comboRotation.SetValue(self.label.rotation)
        #---------------------
        choices = HAlignmentSet
        self.choiceHAlign.SetItems(choices)
        halign = self.label.halignment
        if halign in choices:
            idx = choices.index(halign)
            self.choiceHAlign.SetSelection(idx)
        #---------------------
        choices = VAlignmentSet
        self.choiceVAlign.SetItems(choices)
        valign = self.label.valignment
        if valign in choices:
            idx = choices.index(valign)
            self.choiceVAlign.SetSelection(idx)
        #---------------------
        self.color = self.label.fontcolor
        self.btnColor.set_color(self.color)

    def OnModuleName(self, event=None):
        choices = self.choiceModuleName.GetItems()
        idx = self.choiceModuleName.GetSelection()
        if idx != -1:
            modulename = choices[idx]
        else:
            modulename = None
        if modulename:
            htmltext = self.datainfo.getLabelModuleHelp(modulename)
            if not htmltext:
                htmltext = DefaultText
        else:
            htmltext = DefaultText
        dlg = AboutBox(self, htmltext)
        dlg.ShowModal()
        dlg.Destroy()

    def OnResize(self, event):
        event.Skip()

    def OnIDA(self, event=None):
        wildcard = "text file (*.txt)|*.txt|" \
                "All files (*.*)|*.*"
        dialog = wx.FileDialog(None, "Input filename", os.getcwd(),
                "", wildcard, wx.OPEN)
        result = dialog.ShowModal()
        if result == wx.ID_OK:
            filepath = dialog.GetPath()
        dialog.Destroy()
        if result == wx.ID_OK:
            self.tcIDA.SetValue(filepath)

    def OnRadioButton(self, event=None):
        if self.radioIDA.GetValue():
            self.tcIDA.Enable(True)
            self.btnIDA.Enable(True)
        else:
            self.tcIDA.Enable(False)
            self.btnIDA.Enable(False)

    def OnPositionX(self, event):
        if 0 == len(self.graphinfo.positions): return
        x, y = self.graphinfo.positions[0]
        self.tcPositionX.SetValue("%g" % x)

    def OnPositionY(self, event):
        if 0 == len(self.graphinfo.positions): return
        x, y = self.graphinfo.positions[0]
        self.tcPositionY.SetValue("%g" % y)

    def GetResult(self):
        """
        設定した内容を配列で返す
        """
        posx = float(self.tcPositionX.GetValue())
        posy = float(self.tcPositionY.GetValue())
        choices = self.choiceModuleName.GetItems()
        idx = self.choiceModuleName.GetSelection()
        if idx != -1:
            modulename = choices[idx]
        else:
            modulename = None
        if self.radioIDC.GetValue():
            dataidc = 'C'
        elif self.radioIDR.GetValue():
            dataidc = 'R'
        else:
            dataidc = self.tcIDA.GetValue()
        arg = self.tcArg.GetValue()
        choices = self.choiceFamily.GetItems()
        family = choices[self.choiceFamily.GetSelection()]
        choices = self.choiceStyle.GetItems()
        style = choices[self.choiceStyle.GetSelection()]
        choices = self.choiceWeight.GetItems()
        weight = choices[self.choiceWeight.GetSelection()]
        choices = self.choiceHAlign.GetItems()
        halign = choices[self.choiceHAlign.GetSelection()]
        choices = self.choiceVAlign.GetItems()
        valign = choices[self.choiceVAlign.GetSelection()]
        size = self.comboSize.GetValue()
        rotation = self.comboRotation.GetValue()
        color = self.btnColor.get_color()
        return [posx, posy, modulename, dataidc, arg, 
                family, style, weight, size, color, rotation, halign, valign]

    def OnQuit(self, evt=None):
        self.Close()

if __name__ == '__main__':
    app = wx.App()

    graphinfo = GraphInfo()
    graphinfo.load('plot_default.txt')
    #datainfo = DataInfo()
    datainfo = DataInfo(graphinfo, graphinfo.datamodulefilepath, graphinfo.labelmodulefilepath)

    label = ActiveLabel()
    label.dataidc = 'Hoge'

    dialog = SetActiveLabelDlg(None, label, graphinfo, datainfo)
    result = dialog.ShowModal()
    if result == wx.ID_OK:
        dialogdata = dialog.GetResult()
        print(dialogdata)
    dialog.Destroy()


