#!/usr/bin/env python
# coding: utf-8
# $Id$

import wx
import os
#from MyViewGraphInfo import *
from MyViewConfig import *
try:
    _dummy = wx.Colour
except NameError:
    wx.Colour = wx.Color


class SetFolderDlg(wx.Dialog):
    """
    PATH設定ダイアログ
    """
    def __init__(self, parent, config=None):
        wx.Dialog.__init__(self, parent, -1, 'MyView2 Setup Folder Path', 
                style=wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER)
        
        #self.SetBackgroundColour(wx.Colour(200, 200, 200))
        self.font = wx.Font(11, wx.MODERN, wx.NORMAL, wx.NORMAL, False)
        self.default = MyViewConfig()

        self.config = config
        """
        do not change the values in self.panel and self.graphinfo inside this dialog
        after back to parent, the values in the panel should be changed if the dialog 
        return the wx.ID_OK.
        You can get the values in this dialog with calling dialog.getResult()  
        """

        stCommand = wx.StaticText(self, -1, "Extra Command Path: ")
        stDataModule = wx.StaticText(self, -1, "Data Module Folder Path : ")
        stLabelModule = wx.StaticText(self, -1, "Label Module Folder Path : ")
        stCache = wx.StaticText(self, -1, "Cache Folder Path: ")
        stTemp = wx.StaticText(self, -1, "Temp Folder Path: ")
        stExport = wx.StaticText(self, -1, "Export Folder Path: ")
        stPrint = wx.StaticText(self, -1, "Print Folder Path: ")
        stNotify = wx.StaticText(self, -1, "Notify File Path: ")

        self.tcCommand = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcDataModule = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcLabelModule = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcCache = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcPrint = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcExport = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcTemp = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcNotify = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)

        self.btnCommand = wx.Button(self, -1, 'F')
        self.btnDataModule = wx.Button(self, -1, 'F')
        self.btnLabelModule = wx.Button(self, -1, 'F')
        self.btnCache = wx.Button(self, -1, 'F')
        self.btnExport = wx.Button(self, -1, 'F')
        self.btnPrint = wx.Button(self, -1, 'F')
        self.btnTemp = wx.Button(self, -1, 'F')
        self.btnNotify = wx.Button(self, -1, 'F')

        fgsizer = wx.FlexGridSizer(rows=8, cols=3, hgap=5, vgap=5)
        fgsizer.AddGrowableCol(1)
        fgsizer.Add(stCommand, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.tcCommand, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.btnCommand, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        fgsizer.Add(stDataModule, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.tcDataModule, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.btnDataModule, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        fgsizer.Add(stLabelModule, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.tcLabelModule, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.btnLabelModule, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        fgsizer.Add(stCache, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.tcCache, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.btnCache, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        fgsizer.Add(stTemp, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.tcTemp, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.btnTemp, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        fgsizer.Add(stExport, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.tcExport, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.btnExport, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        fgsizer.Add(stPrint, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.tcPrint, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.btnPrint, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        fgsizer.Add(stNotify, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.tcNotify, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.btnNotify, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        btnOk = wx.Button(self, wx.ID_OK, "OK")
        btnOk.SetDefault()
        btnCancel= wx.Button(self, wx.ID_CANCEL, "Cancel")
        btnSetDefault= wx.Button(self, -1, "Set Default")
        btnsizer = wx.BoxSizer(wx.HORIZONTAL)
        btnsizer.Add(btnOk, 1, wx.EXPAND)
        btnsizer.Add(btnCancel, 1, wx.EXPAND)
        btnsizer.Add((20, 20), 1, wx.EXPAND)
        btnsizer.Add(btnSetDefault, 1, wx.EXPAND)
        
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(fgsizer, 0, wx.EXPAND|wx.ALL)
        sizer.Add(btnsizer, 0, wx.EXPAND|wx.ALL, 5)
        
        self.SetSizer(sizer)
        self.Fit()

        self.Bind(wx.EVT_BUTTON, self.OnFolderSelect, self.btnCommand)
        self.Bind(wx.EVT_BUTTON, self.OnFolderSelect, self.btnDataModule)
        self.Bind(wx.EVT_BUTTON, self.OnFolderSelect, self.btnLabelModule)
        self.Bind(wx.EVT_BUTTON, self.OnFolderSelect, self.btnCache)
        self.Bind(wx.EVT_BUTTON, self.OnFolderSelect, self.btnTemp)
        self.Bind(wx.EVT_BUTTON, self.OnFolderSelect, self.btnExport)
        self.Bind(wx.EVT_BUTTON, self.OnFolderSelect, self.btnPrint)
        self.Bind(wx.EVT_BUTTON, self.OnFolderSelect, self.btnNotify)
        self.Bind(wx.EVT_BUTTON, self.OnSetDefault, btnSetDefault)
        self.Bind(wx.EVT_SIZE, self.OnResize, self)
        
        self.SetStateFirst()

    def SetStateFirst(self):
        """
        Setup the value of widgets on this dialog 
        by referencing with self.group and self.graphinfo.
        """
        self.tcCommand.SetValue("%s" % self.config['commandfoldername'])
        self.tcDataModule.SetValue("%s" % self.config['datamodulefoldername'])
        self.tcLabelModule.SetValue("%s" % self.config['labelmodulefoldername'])
        self.tcCache.SetValue("%s" % self.config['cachefoldername'])
        self.tcTemp.SetValue("%s" % self.config['tempfoldername'])
        self.tcExport.SetValue("%s" % self.config['exportfoldername'])
        self.tcPrint.SetValue("%s" % self.config['printfoldername'])
        self.tcNotify.SetValue("%s" % self.config['notifyfoldername'])

    def OnResize(self, event):
        event.Skip()

    def OnFolderSelect(self, event=None):
        obj = event.GetEventObject()
        if obj == self.btnCommand:
            tc = self.tcCommand
        elif obj == self.btnDataModule:
            tc = self.tcDataModule
        elif obj == self.btnLabelModule:
            tc = self.tcLabelModule
        elif obj == self.btnCache:
            tc = self.tcCache
        elif obj == self.btnTemp:
            tc = self.tcTemp
        elif obj == self.btnExport:
            tc = self.tcExport
        elif obj == self.btnPrint:
            tc = self.tcPrint
        else:
            tc = self.tcNotify

        path = tc.GetValue()
        default = os.path.join(os.getcwd(), path)
        dialog = wx.DirDialog(self, "Select Folder", default,  
                style=wx.DD_DEFAULT_STYLE)
        if dialog.ShowModal() == wx.ID_OK:
            selectpath = dialog.GetPath()
            tc.SetValue("%s" % selectpath)
        dialog.Destroy()

    def OnSetDefault(self, event=None):
        """
        Defaultボタンのコールバック
        """
        self.tcCommand.SetValue("%s" % self.default['commandfoldername'])
        self.tcDataModule.SetValue("%s" % self.default['datamodulefoldername'])
        self.tcLabelModule.SetValue("%s" % self.default['labelmodulefoldername'])
        self.tcCache.SetValue("%s" % self.default['cachefoldername'])
        self.tcTemp.SetValue("%s" % self.default['tempfoldername'])
        self.tcExport.SetValue("%s" % self.default['exportfoldername'])
        self.tcPrint.SetValue("%s" % self.default['printfoldername'])
        self.tcNotify.SetValue("%s" % self.default['notifyfoldername'])

    def GetResult(self):
        """
        設定内容を返す
        """
        commandfolderpath = self.tcCommand.GetValue()
        datamodulefolderpath = self.tcDataModule.GetValue()
        labelmodulefolderpath = self.tcLabelModule.GetValue()
        cachefolderpath = self.tcCache.GetValue()
        tempfolderpath = self.tcTemp.GetValue()
        exportfolderpath = self.tcExport.GetValue()
        printfolderpath = self.tcPrint.GetValue()
        notifyfolderpath = self.tcNotify.GetValue()

        return [commandfolderpath,
                datamodulefolderpath,
                labelmodulefolderpath,
                cachefolderpath,
                tempfolderpath,
                exportfolderpath,
                printfolderpath,
                notifyfolderpath]

    def OnQuit(self, evt=None):
        """
        ダイアログのクローズ
        """
        self.Close()

if __name__ == '__main__':
    app = wx.App()

    config = MyViewConfig()

    dialog = SetFolderDlg(None, config)
    result = dialog.ShowModal()
    if result == wx.ID_OK:
        dialogdata = dialog.GetResult()
        print(dialogdata)
    dialog.Destroy()


