#!/usr/bin/env python
# coding: utf-8
# $Id$

import wx
from MyViewSetLabelDlg import *
from MyViewSetTickLabelDlg import *
try:
    _dummy = wx.Colour
except NameError:
    wx.Colour = wx.Color

class SetGroupDlg(wx.Dialog):
    """
    グループ設定用ダイアログ
    """
    def __init__(self, parent, group=None, graphinfo=None):
        wx.Dialog.__init__(self, parent, -1, 'MyView2 Setup Group', 
                style=wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER | wx.STAY_ON_TOP)
        
        #self.SetBackgroundColour(wx.Colour(200, 200, 200))
        self.font = wx.Font(11, wx.MODERN, wx.NORMAL, wx.NORMAL, False)

        self.group = group
        self.graphinfo = graphinfo
        """
        do not change the values in self.group and self.graphinfo inside this dialog
        after back to parent, the value in the group should be changed if the dialog 
        return the wx.ID_OK.
        You can get the values in this dialog with calling dialog.getResult()  
        """

        stLeft = wx.StaticText(self, -1, "Left: ")
        self.tcLeft = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        stBottom = wx.StaticText(self, -1, "Bottom: ")
        self.tcBottom = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        stWidth = wx.StaticText(self, -1, "Width: ")
        self.tcWidth = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        stHeight = wx.StaticText(self, -1, "Height: ")
        self.tcHeight = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        fgsizerPosition = wx.FlexGridSizer(rows=4, cols=2, hgap=5, vgap=5)
        fgsizerPosition.AddGrowableCol(1)
        fgsizerPosition.Add(stLeft, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerPosition.Add(self.tcLeft, 1, wx.EXPAND)
        fgsizerPosition.Add(stBottom, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerPosition.Add(self.tcBottom, 1, wx.EXPAND)
        fgsizerPosition.Add(stWidth, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerPosition.Add(self.tcWidth, 1, wx.EXPAND)
        fgsizerPosition.Add(stHeight, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerPosition.Add(self.tcHeight, 1, wx.EXPAND)
        
        stRow = wx.StaticText(self, -1, "Num Rows: ")
        stColumn = wx.StaticText(self, -1, "Num Cols: ")
        self.tcRow = wx.TextCtrl(self, -1, "", style=wx.TE_PROCESS_ENTER)
        self.tcColumn = wx.TextCtrl(self, -1, "", style=wx.TE_PROCESS_ENTER)
        stGap = wx.StaticText(self, -1, "Gap: ")
        self.tcGap = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)

        fgsizerMulti = wx.FlexGridSizer(rows=3, cols=2, hgap=5, vgap=5)
        fgsizerMulti.AddGrowableCol(0)
        fgsizerMulti.AddGrowableCol(1)
        fgsizerMulti.Add(stRow, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerMulti.Add(self.tcRow, 1, wx.EXPAND)
        fgsizerMulti.Add(stColumn, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerMulti.Add(self.tcColumn, 1, wx.EXPAND)
        fgsizerMulti.Add(stGap, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerMulti.Add(self.tcGap, 1, wx.EXPAND)

        stLabelT = wx.StaticText(self, -1, "Title: ")
        self.tcLabelT = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.btnLabelT = wx.Button(self, -1, 'more')
        stMin = wx.StaticText(self, -1, "Min: ")
        stMax = wx.StaticText(self, -1, "Max: ")
        self.btnX = wx.Button(self, -1, "X: ")
        stLabelX = wx.StaticText(self, -1, "Label X: ")
        self.btnY = wx.Button(self, -1, "Y: ")
        stLabelY = wx.StaticText(self, -1, "Label Y: ")
        stCommonY = wx.StaticText(self, -1, ":Common Y ")
        stShowLegY = wx.StaticText(self, -1, ":Show Leggend Y")
        stLogX = wx.StaticText(self, -1, ":Log Scale X")
        stLogY = wx.StaticText(self, -1, ":Log Scale Y ")
        self.tcXmin = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcXmax = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcLabelX = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.btnLabelX = wx.Button(self, -1, 'more')
        self.tcYmin = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcYmax = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcLabelY = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.btnLabelY = wx.Button(self, -1, 'more')
        self.cbCommonY = wx.CheckBox(self, -1, "")
        self.cbShowLegY = wx.CheckBox(self, -1, "")
        self.cbLogX = wx.CheckBox(self, -1, "")
        self.cbLogY = wx.CheckBox(self, -1, "")
        stLinkX = wx.StaticText(self, -1, "X Link to :")
        self.choiceLinkX = wx.Choice(self, -1, size=(100, 30), choices=[])
        stLinkY = wx.StaticText(self, -1, "Y Link to :")
        self.choiceLinkY = wx.Choice(self, -1, size=(100, 30), choices=[])

        fgsizerRange = wx.FlexGridSizer(rows=12, cols=3, hgap=5, vgap=5)
        fgsizerRange.AddGrowableCol(1)
        fgsizerRange.AddGrowableCol(2)
        #1
        fgsizerRange.Add(stLabelT, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcLabelT, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.btnLabelT, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #2
        fgsizerRange.Add((20, 20), 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stMin, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stMax, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #3
        fgsizerRange.Add(self.btnX, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcXmin, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcXmax, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #4
        fgsizerRange.Add(stLabelX, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcLabelX, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.btnLabelX, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #5
        fgsizerRange.Add(self.cbLogX, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stLogX, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #6
        fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stLinkX, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.choiceLinkX, 1, wx.EXPAND)
        #7
        fgsizerRange.Add(self.cbCommonY, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stCommonY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #8
        fgsizerRange.Add(self.btnY, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcYmin, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcYmax, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #9
        fgsizerRange.Add(stLabelY, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcLabelY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.btnLabelY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #10
        fgsizerRange.Add(self.cbLogY, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stLogY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #11
        fgsizerRange.Add(self.cbShowLegY, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stShowLegY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #12
        fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stLinkY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.choiceLinkY, 1, wx.EXPAND)

        btnOk = wx.Button(self, wx.ID_OK, "OK")
        btnOk.SetDefault()
        btnCancel= wx.Button(self, wx.ID_CANCEL, "Cancel")
        btnsizer = wx.BoxSizer(wx.HORIZONTAL)
        btnsizer.Add(btnOk, 1, wx.EXPAND)
        btnsizer.Add(btnCancel, 1, wx.EXPAND)
        
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(fgsizerPosition, 1, wx.EXPAND|wx.ALL)
        sizer.Add((20, 10), 0, wx.EXPAND|wx.ALL)
        sizer.Add(fgsizerMulti, 0, wx.EXPAND|wx.ALL)
        sizer.Add((20, 10), 0, wx.EXPAND|wx.ALL)
        sizer.Add(fgsizerRange, 0, wx.EXPAND|wx.ALL)
        sizer.Add(btnsizer, 0, wx.EXPAND|wx.ALL, 5)
        
        self.SetSizer(sizer)
        self.Fit()

        self.tcLeft.Bind(wx.EVT_TEXT_ENTER, self.OnLeft, self.tcLeft)
        self.tcLeft.Bind(wx.EVT_KILL_FOCUS, self.OnLeft, self.tcLeft)
        self.tcBottom.Bind(wx.EVT_TEXT_ENTER, self.OnBottom, self.tcBottom)
        self.tcBottom.Bind(wx.EVT_KILL_FOCUS, self.OnBottom, self.tcBottom)
        self.tcWidth.Bind(wx.EVT_TEXT_ENTER, self.OnWidth, self.tcWidth)
        self.tcWidth.Bind(wx.EVT_KILL_FOCUS, self.OnWidth, self.tcWidth)
        self.tcHeight.Bind(wx.EVT_TEXT_ENTER, self.OnHeight, self.tcHeight)
        self.tcHeight.Bind(wx.EVT_KILL_FOCUS, self.OnHeight, self.tcHeight)
        self.cbCommonY.Bind(wx.EVT_CHECKBOX, self.OnCommonY, self.cbCommonY)
        self.Bind(wx.EVT_SIZE, self.OnResize, self)

        self.tcXmin.Bind(wx.EVT_TEXT_ENTER, self.OnMin, self.tcXmin)
        self.tcXmin.Bind(wx.EVT_KILL_FOCUS, self.OnMin, self.tcXmin)
        self.tcXmax.Bind(wx.EVT_TEXT_ENTER, self.OnMax, self.tcXmax)
        self.tcXmax.Bind(wx.EVT_KILL_FOCUS, self.OnMax, self.tcXmax)
        self.tcYmin.Bind(wx.EVT_TEXT_ENTER, self.OnMin, self.tcYmin)
        self.tcYmin.Bind(wx.EVT_KILL_FOCUS, self.OnMin, self.tcYmin)
        self.tcYmax.Bind(wx.EVT_TEXT_ENTER, self.OnMax, self.tcYmax)
        self.tcYmax.Bind(wx.EVT_KILL_FOCUS, self.OnMax, self.tcYmax)
        self.tcRow.Bind(wx.EVT_TEXT_ENTER, self.OnRow, self.tcRow)
        self.tcRow.Bind(wx.EVT_KILL_FOCUS, self.OnRow, self.tcRow)
        self.tcColumn.Bind(wx.EVT_TEXT_ENTER, self.OnColumn, self.tcColumn)
        self.tcColumn.Bind(wx.EVT_KILL_FOCUS, self.OnColumn, self.tcColumn)
        self.Bind(wx.EVT_BUTTON, self.OnLabelXYT, self.btnLabelX)
        self.Bind(wx.EVT_BUTTON, self.OnLabelXYT, self.btnLabelY)
        self.Bind(wx.EVT_BUTTON, self.OnLabelXYT, self.btnLabelT)
        self.Bind(wx.EVT_BUTTON, self.OnTickXY, self.btnX)
        self.Bind(wx.EVT_BUTTON, self.OnTickXY, self.btnY)

        self.SetStateFirst()

    def SetStateFirst(self):
        """
        Setup the value of widgets on this dialog 
        by referencing with self.group and self.graphinfo.
        """
        self.left = self.group.left 
        self.bottom = self.group.bottom
        self.width = self.group.width
        self.height = self.group.height
        self.gap = self.group.gap
        self.tcLeft.SetValue("%g" % self.left)
        self.tcBottom.SetValue("%g" % self.bottom)
        self.tcWidth.SetValue("%g" % self.width)
        self.tcHeight.SetValue("%g" % self.height)
        self.tcGap.SetValue("%g" % self.gap)
        self.numrows = self.group.numrows 
        self.tcRow.SetValue("%d" % self.numrows)
        self.numcols = self.group.numcols
        self.tcColumn.SetValue("%d" % self.numcols)
        self.tcLabelT.SetValue("%s" % self.group.labelt.text)
        self.xmin = self.group.xmin
        self.xmax = self.group.xmax
        self.ymin = self.group.ymin
        self.ymax = self.group.ymax
        self.tcXmin.SetValue("%g" % self.xmin)
        self.tcXmax.SetValue("%g" % self.xmax)
        self.tcLabelX.SetValue("%s" % self.group.labelx.text)
        self.tcYmin.SetValue("%g" % self.ymin)
        self.tcYmax.SetValue("%g" % self.ymax)
        self.tcLabelY.SetValue("%s" % self.group.labely.text)
        flgcommony = self.group.flgcommony
        self.cbCommonY.SetValue(flgcommony)
        self.tcYmin.Enable(flgcommony)
        self.tcYmax.Enable(flgcommony)
        self.tcLabelY.Enable(flgcommony)
        self.btnLabelY.Enable(flgcommony)
        self.cbLogY.Enable(flgcommony)
        self.cbShowLegY.Enable(flgcommony)
        self.cbShowLegY.SetValue(self.group.flgshowlegy)
        self.choiceLinkY.Enable(flgcommony)
        flglogx = self.group.flglogx
        self.cbLogX.SetValue(flglogx)
        flglogy = self.group.flglogy
        self.cbLogY.SetValue(flglogy)
        linkx = self.group.linkx
        linky = self.group.linky

        choices = self.graphinfo.getGroupChoices()
        choices = choices + ['Unlink']
        self.choiceLinkX.SetItems(choices)
        self.choiceLinkY.SetItems(choices)
        if linkx:
            self.choiceLinkX.SetSelection(linkx.groupid)
        else:
            self.choiceLinkX.SetSelection(len(choices)-1)
        if linky:
            self.choiceLinkY.SetSelection(linky.groupid)
        else:
            self.choiceLinkY.SetSelection(len(choices)-1)

    def OnResize(self, event):
        event.Skip()

    def GetResult(self):
        """
        設定した内容を配列で返す
        """
        left = float(self.tcLeft.GetValue())
        bottom = float(self.tcBottom.GetValue())
        width = float(self.tcWidth.GetValue())
        height = float(self.tcHeight.GetValue())
        gap = float(self.tcGap.GetValue())
        numrows = int(self.tcRow.GetValue())
        numcols = int(self.tcColumn.GetValue())
        textt = self.tcLabelT.GetValue()
        xmin = float(self.tcXmin.GetValue())
        xmax = float(self.tcXmax.GetValue())
        textx = self.tcLabelX.GetValue()
        ymin = float(self.tcYmin.GetValue())
        ymax = float(self.tcYmax.GetValue())
        texty = self.tcLabelY.GetValue()
        flgcommony = self.cbCommonY.GetValue()
        flglogx = self.cbLogX.GetValue()
        flglogy = self.cbLogY.GetValue()
        flgshowlegy = self.cbShowLegY.GetValue()
        linkidx = self.choiceLinkX.GetSelection()
        linkidy = self.choiceLinkY.GetSelection()
        if linkidx == len(self.choiceLinkX.GetItems())-1:
            linkidx = -1
        if linkidy == len(self.choiceLinkY.GetItems())-1:
            linkidy = -1

        if xmin > xmax:
            xmin, xmax = xmax, xmin
        if ymin > ymax:
            ymin, ymax = ymax, ymin

        return [left, bottom, width, height, gap, 
                numrows, numcols, textt, xmin, xmax, flglogx, textx, 
                flgcommony, ymin, ymax, flglogy, flgshowlegy, texty,
                linkidx, linkidy]

    def OnLabelXYT(self, event=None):
        obj = event.GetEventObject()
        if obj == self.btnLabelX:
            label = self.group.labelx
            label.setData(text = self.tcLabelX.GetValue())
        elif obj == self.btnLabelY:
            label = self.group.labely
            label.setData(text = self.tcLabelY.GetValue())
        else:
            label = self.group.labelt
            label.setData(text = self.tcLabelT.GetValue())

        dialog = SetLabelDlg(self, label, self.graphinfo)
        result = dialog.ShowModal()
        if result == wx.ID_OK:
            dialogdata = dialog.GetResult()
            [text, family, style, weight, size, color, rotation, 
                    halign, valign] = dialogdata
            label.setData(
                    text = text,
                    fontfamily = family,
                    fontstyle =style,
                    fontweight = weight,
                    fontsize = size,
                    fontcolor = color,
                    rotation = rotation,
                    halignment = halign,
                    valignment = valign)
            if obj == self.btnLabelX:
                self.tcLabelX.SetValue("%s" % text)
            elif obj == self.btnLabelY:
                self.tcLabelY.SetValue("%s" % text)
            else:
                self.tcLabelT.SetValue("%s" % text)
        dialog.Destroy()

    def OnTickXY(self, event=None):
        obj = event.GetEventObject()
        if obj == self.btnX:
            ticklabel = self.group.ticklabelx
        else:
            ticklabel = self.group.ticklabely
        dialog = SetTickLabelDlg(self, ticklabel, self.graphinfo)
        result = dialog.ShowModal()
        if result == wx.ID_OK:
            dialogdata = dialog.GetResult()
            [fmt, family, style, weight, size, color, rotation, 
                    halign, valign, flgtrimfirst, flgtrimlast] = dialogdata
            ticklabel.setData(
                    fmt = fmt,
                    fontfamily = family,
                    fontstyle =style,
                    fontweight = weight,
                    fontsize = size,
                    fontcolor = color,
                    rotation = rotation,
                    halignment = halign,
                    valignment = valign,
                    flgtrimfirst = flgtrimfirst,
                    flgtrimlast = flgtrimlast)
        dialog.Destroy()

    def OnRow(self, event=None):
        event.Skip()
        vstr = self.tcRow.GetValue()
        try:
            v = int(vstr)
            self.tcRow.SetValue('%d' % v)
            self.numrows = v
        except:
            self.tcRow.SetValue('%d' % self.numrows)

    def OnColumn(self, event=None):
        event.Skip()
        vstr = self.tcColumn.GetValue()
        try:
            v = int(vstr)
            self.tcColumn.SetValue('%d' % v)
            self.numcols = v
        except:
            self.tcColumn.SetValue('%d' % self.numcols)

    def OnLeft(self, event=None):
        event.Skip()
        vstr = self.tcLeft.GetValue()
        v = float(vstr)
        if v >= 0.0 and self.width + v <= 1.0:
            self.left = v
            self.tcLeft.SetValue('%g' % self.left)
        else:
            self.tcLeft.SetValue('%g' % self.left)

    def OnBottom(self, event=None):
        event.Skip()
        vstr = self.tcBottom.GetValue()
        v = float(vstr)
        if v >= 0.0 and self.height + v <= 1.0:
            self.bottom = v
            self.tcBottom.SetValue('%g' % self.bottom)
        else:
            self.tcBottom.SetValue('%g' % self.bottom)
    
    def OnWidth(self, event=None):
        event.Skip()
        vstr = self.tcWidth.GetValue()
        v = float(vstr)
        if v >= 0.0 and self.left + v <= 1.0:
            self.width = v
            self.tcWidth.SetValue('%g' % self.width)
        else:
            self.tcWidth.SetValue('%g' % self.width)

    def OnHeight(self, event=None):
        event.Skip()
        vstr = self.tcHeight.GetValue()
        v = float(vstr)
        if v >= 0.0 and self.bottom + v <= 1.0:
            self.height = v
            self.tcHeight.SetValue('%g' % self.height)
        else:
            self.tcHeight.SetValue('%g' % self.height)

    def OnCommonY(self, event=None):
        flg = self.cbCommonY.GetValue()
        self.tcYmin.Enable(flg)
        self.tcYmax.Enable(flg)
        self.cbLogY.Enable(flg)
        self.tcLabelY.Enable(flg)
        self.btnLabelY.Enable(flg)
        self.choiceLinkY.Enable(flg)
        self.cbShowLegY.Enable(flg)

    def OnMin(self, event):
        event.Skip()
        tc = event.GetEventObject()
        if tc == self.tcXmin:
            vorg = self.xmin
            vmax = self.xmax
        elif tc == self.tcYmin:
            vorg = self.ymin
            vmax = self.ymax
        sv = tc.GetValue()
        try:
            v = float(sv)
        except ValueError:
            tc.SetValue("%g" % vorg)
        self.xmin = float(self.tcXmin.GetValue())
        self.ymin = float(self.tcYmin.GetValue())

    def OnMax(self, event):
        event.Skip()
        tc = event.GetEventObject()
        if tc == self.tcXmax:
            vorg = self.xmax
            vmin = self.xmin
        elif tc == self.tcYmax:
            vorg = self.ymax
            vmin = self.ymin
        sv = tc.GetValue()
        try:
            v = float(sv)
        except ValueError:
            tc.SetValue("%g" % vorg)
        self.xmax = float(self.tcXmax.GetValue())
        self.ymax = float(self.tcYmax.GetValue())

    def OnQuit(self, evt=None):
        self.Close()

if __name__ == '__main__':
    from MyViewGraphInfo import *

    app = wx.App()

    graphinfo = GraphInfo()
    graphinfo.load('plot_default.txt')

    group = graphinfo.groups[0]

    dialog = SetGroupDlg(None, group, graphinfo)
    result = dialog.ShowModal()
    if result == wx.ID_OK:
        dialogdata = dialog.GetResult()
        print(dialogdata)
    dialog.Destroy()


