#!/usr/bin/env python
# coding: utf-8
# $Id$

import wx
from MyViewSetLabelDlg import *
from MyViewSetTickLabelDlg import *
from MyViewSetLabelStyleDlg import *

try:
    _dummy = wx.Colour
except NameError:
    wx.Colour = wx.Color

class SetPanelDlg(wx.Dialog):
    """
    パネル設定用ダイアログ
    """
    def __init__(self, parent, panel=None, graphinfo=None):
        wx.Dialog.__init__(self, parent, -1, 'MyView2 Setup Panel', 
                style=wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER)
        
        #self.SetBackgroundColour(wx.Colour(200, 200, 200))
        self.font = wx.Font(11, wx.MODERN, wx.NORMAL, wx.NORMAL, False)

        self.panel = panel
        self.graphinfo = graphinfo
        """
        do not change the values in self.panel and self.graphinfo inside this dialog
        after back to parent, the values in the panel should be changed if the dialog 
        return the wx.ID_OK.
        You can get the values in this dialog with calling dialog.getResult()  
        """

        stMin = wx.StaticText(self, -1, "Min: ")
        stMax = wx.StaticText(self, -1, "Max: ")
        self.btnX = wx.Button(self, -1, "X: ")
        self.btnY = wx.Button(self, -1, "Y: ")
        stLabelX = wx.StaticText(self, -1, "LabelX: ")
        stLabelY = wx.StaticText(self, -1, "LabelY: ")
        stMinor = wx.StaticText(self, -1, "Minor: ")
        stMajor = wx.StaticText(self, -1, "Major: ")
        stInterval = wx.StaticText(self, -1, "Interval: ")
        self.stLabelS = wx.StaticText(self, -1, "LabelS: ")
        self.btnS = wx.Button(self, -1, "Y2: ")
        stCommonY = wx.StaticText(self, -1, ":Common Y ")
        stLogX = wx.StaticText(self, -1, ":Log Scale X")
        stLogY = wx.StaticText(self, -1, ":Log Scale Y ")
        stGridY = wx.StaticText(self, -1, ":Show Grid Y ")
        stShowLegY = wx.StaticText(self, -1, ":Show Leggend Y ")
        self.stLogS = wx.StaticText(self, -1, ":Log Scale Y2 ")
        self.stShowLegS = wx.StaticText(self, -1, ":Show leggend Y2 ")
        self.tcXmin = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcXmax = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcYmin = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcYmax = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcSmin = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcSmax = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcLabelX = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcLabelY = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcLabelS = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcInterval = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcInterval2 = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.btnLabelX = wx.Button(self, -1, 'more')
        self.btnLabelY = wx.Button(self, -1, 'more')
        self.btnLegendY = wx.Button(self, -1, 'more')
        self.btnLegendS = wx.Button(self, -1, 'more')
        self.btnLabelS = wx.Button(self, -1, 'more')
        self.cbCommonY = wx.CheckBox(self, -1, "")
        self.cbLogX = wx.CheckBox(self, -1, "")
        self.cbLogY = wx.CheckBox(self, -1, "")
        self.cbLogS = wx.CheckBox(self, -1, "")
        self.cbGridY = wx.CheckBox(self, -1, "")
        self.cbShowLegY = wx.CheckBox(self, -1, "")
        self.cbShowLegS = wx.CheckBox(self, -1, "")
        stLinkY = wx.StaticText(self, -1, "Y Link to :")
        self.choiceLinkYG = wx.Choice(self, -1, size=(100, 30), choices=[])
        self.choiceLinkYP = wx.Choice(self, -1, size=(100, 30), choices=[])
       
        #self.radiopanel = wx.Panel(self, -1)
        self.radioxy = wx.RadioButton(self, -1, "xy", style=wx.RB_GROUP)
        self.radioxy2 = wx.RadioButton(self, -1, "xy-y2")
        self.radioxyz = wx.RadioButton(self, -1, "xy-z")
        
        fgsizerRange = wx.FlexGridSizer(rows=18, cols=3, hgap=5, vgap=5)
        fgsizerRange.AddGrowableCol(1)
        fgsizerRange.AddGrowableCol(2)
        #1
        fgsizerRange.Add((20, 20), 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stMin, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stMax, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #2
        fgsizerRange.Add(self.btnX, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcXmin, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcXmax, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #3
        fgsizerRange.Add(stLabelX, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcLabelX, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.btnLabelX, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #4
        fgsizerRange.Add(self.cbLogX, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stLogX, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #5
        fgsizerRange.Add(self.btnY, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcYmin, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcYmax, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #6
        fgsizerRange.Add(stLabelY, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcLabelY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.btnLabelY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #7
        fgsizerRange.Add(self.cbLogY, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stLogY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #8 
        fgsizerRange.Add(self.cbGridY, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stGridY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #9
        fgsizerRange.Add(self.cbShowLegY, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stShowLegY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.btnLegendY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #10 
        fgsizerRange.Add(self.cbCommonY, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stCommonY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #11 
        fgsizerRange.Add(self.radioxy, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.radioxy2, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.radioxyz, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #12
        fgsizerRange.Add(self.btnS, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcSmin, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcSmax, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #1
        fgsizerRange.Add((20, 20), 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stMinor, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(stMajor, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #14
        fgsizerRange.Add(stInterval, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcInterval, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcInterval2, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #15
        fgsizerRange.Add(self.stLabelS, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.tcLabelS, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.btnLabelS, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        
        #16
        fgsizerRange.Add(self.cbLogS, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.stLogS, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.btnLegendS, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #17 
        fgsizerRange.Add(self.cbShowLegS, 0, wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.stShowLegS, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add((20, 20), 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        #18
        fgsizerRange.Add(stLinkY, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizerRange.Add(self.choiceLinkYG, 1, wx.EXPAND)
        fgsizerRange.Add(self.choiceLinkYP, 1, wx.EXPAND)

        btnOk = wx.Button(self, wx.ID_OK, "OK")
        btnOk.SetDefault()
        btnCancel= wx.Button(self, wx.ID_CANCEL, "Cancel")
        btnsizer = wx.BoxSizer(wx.HORIZONTAL)
        btnsizer.Add(btnOk, 1, wx.EXPAND)
        btnsizer.Add(btnCancel, 1, wx.EXPAND)
        
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(fgsizerRange, 0, wx.EXPAND|wx.ALL)
        sizer.Add(btnsizer, 0, wx.EXPAND|wx.ALL, 5)
        
        self.SetSizer(sizer)
        self.Fit()

        self.cbCommonY.Bind(wx.EVT_CHECKBOX, self.OnCommonY, self.cbCommonY)
        self.Bind(wx.EVT_SIZE, self.OnResize, self)

        self.tcXmin.Bind(wx.EVT_TEXT_ENTER, self.OnMin, self.tcXmin)
        self.tcXmin.Bind(wx.EVT_KILL_FOCUS, self.OnMin, self.tcXmin)
        self.tcXmax.Bind(wx.EVT_TEXT_ENTER, self.OnMax, self.tcXmax)
        self.tcXmax.Bind(wx.EVT_KILL_FOCUS, self.OnMax, self.tcXmax)
        self.tcYmin.Bind(wx.EVT_TEXT_ENTER, self.OnMin, self.tcYmin)
        self.tcYmin.Bind(wx.EVT_KILL_FOCUS, self.OnMin, self.tcYmin)
        self.tcYmax.Bind(wx.EVT_TEXT_ENTER, self.OnMax, self.tcYmax)
        self.tcYmax.Bind(wx.EVT_KILL_FOCUS, self.OnMax, self.tcYmax)
        self.tcSmin.Bind(wx.EVT_TEXT_ENTER, self.OnMin, self.tcSmin)
        self.tcSmin.Bind(wx.EVT_KILL_FOCUS, self.OnMin, self.tcSmin)
        self.tcSmax.Bind(wx.EVT_TEXT_ENTER, self.OnMax, self.tcSmax)
        self.tcSmax.Bind(wx.EVT_KILL_FOCUS, self.OnMax, self.tcSmax)
        self.tcInterval.Bind(wx.EVT_TEXT_ENTER, self.OnInterval, self.tcInterval)
        self.tcInterval.Bind(wx.EVT_KILL_FOCUS, self.OnInterval, self.tcInterval)
        self.tcInterval2.Bind(wx.EVT_TEXT_ENTER, self.OnInterval2, self.tcInterval2)
        self.tcInterval2.Bind(wx.EVT_KILL_FOCUS, self.OnInterval2, self.tcInterval2)
        
        self.Bind(wx.EVT_CHOICE, self.OnChoiceLinkYG, self.choiceLinkYG)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioButton, self.radioxy)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioButton, self.radioxy2)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioButton, self.radioxyz)
        self.Bind(wx.EVT_BUTTON, self.OnLabelXYS, self.btnLabelX)
        self.Bind(wx.EVT_BUTTON, self.OnLabelXYS, self.btnLabelY)
        self.Bind(wx.EVT_BUTTON, self.OnLabelXYS, self.btnLabelS)
        self.Bind(wx.EVT_BUTTON, self.OnTickLabelXYS, self.btnX)
        self.Bind(wx.EVT_BUTTON, self.OnTickLabelXYS, self.btnY)
        self.Bind(wx.EVT_BUTTON, self.OnTickLabelXYS, self.btnS)
        self.Bind(wx.EVT_BUTTON, self.OnLegendStyleYS, self.btnLegendY)
        self.Bind(wx.EVT_BUTTON, self.OnLegendStyleYS, self.btnLegendS)

        self.SetStateFirst()

    def SetStateFirst(self):
        """
        Setup the value of widgets on this dialog 
        by referencing with self.group and self.graphinfo.
        """
        self.xmin = self.panel.group.xmin
        self.xmax = self.panel.group.xmax
        self.interval = self.panel.interval
        self.interval2 = self.panel.interval2
        self.tcLabelX.SetValue("%s" % self.panel.group.labelx.text)
        flglogx = self.panel.group.flglogx
        self.cbLogX.SetValue(flglogx)
        flgcommony = self.panel.group.flgcommony
        self.cbCommonY.SetValue(flgcommony)
        if flgcommony:
            self.ymin = self.panel.group.ymin
            self.ymax = self.panel.group.ymax
            self.tcLabelY.SetValue("%s" % self.panel.group.labely.text)
            flglogy = self.panel.group.flglogy
            self.cbLogY.SetValue(flglogy)
            flgshowlegy = self.panel.group.flgshowlegy
            self.cbShowLegY.SetValue(flgshowlegy)
        else:
            self.ymin = self.panel.ymin
            self.ymax = self.panel.ymax
            self.tcLabelY.SetValue("%s" % self.panel.labely.text)
            flglogy = self.panel.flglogy
            self.cbLogY.SetValue(flglogy)
            flgshowlegy = self.panel.flgshowlegy
            self.cbShowLegY.SetValue(flgshowlegy)
        flggrid = self.panel.flggrid
        self.cbGridY.SetValue(flggrid)

        self.smin = self.panel.smin
        self.smax = self.panel.smax
        self.tcLabelS.SetValue("%s" % self.panel.labels.text)

        self.tcXmin.SetValue("%g" % self.xmin)
        self.tcXmax.SetValue("%g" % self.xmax)
        self.tcYmin.SetValue("%g" % self.ymin)
        self.tcYmax.SetValue("%g" % self.ymax)
        self.tcSmin.SetValue("%g" % self.smin)
        self.tcSmax.SetValue("%g" % self.smax)
        self.tcInterval.SetValue("%g" % self.interval)
        self.tcInterval2.SetValue("%g" % self.interval2)
        self.cbShowLegS.SetValue(self.panel.flgshowlegs)

        ptype = self.panel.ptype
        if ptype == 0:
            self.radioxy.SetValue(True)
            self.tcSmin.Enable(False)
            self.tcSmax.Enable(False)
            self.tcLabelS.Enable(False)
            self.btnLabelS.Enable(False)
            self.btnLegendS.Enable(False)
            self.cbLogS.Enable(False)
            self.btnS.SetLabel("Y2: ")
            self.stLogS.SetLabel(":Log Scale Y2 ")
            self.stShowLegS.SetLabel(":Show Legend ")
            self.cbShowLegS.Enable(False)
            self.tcInterval.Enable(False)
            self.tcInterval2.Enable(False)
        elif ptype == 1:
            self.radioxy2.SetValue(True)
            self.tcSmin.Enable(True)
            self.tcSmax.Enable(True)
            self.tcLabelS.Enable(True)
            self.btnLabelS.Enable(True)
            self.btnLegendS.Enable(True)
            self.cbLogS.Enable(True)
            self.btnS.SetLabel("Y2: ")
            self.stLogS.SetLabel(":Log Scale Y2 ")
            self.stShowLegS.SetLabel(":Show Legend Y2 ")
            self.cbShowLegS.Enable(True)
            self.tcInterval.Enable(False)
            self.tcInterval2.Enable(False)
        else:
            self.radioxyz.SetValue(True)
            self.tcSmin.Enable(True)
            self.tcSmax.Enable(True)
            self.tcLabelS.Enable(True)
            self.btnLabelS.Enable(True)
            self.btnLegendS.Enable(True)
            self.cbLogS.Enable(True)
            self.btnS.SetLabel("Z: ")
            self.stLogS.SetLabel(":Log Scale Z ")
            self.stShowLegS.SetLabel(":Show Legend Z ")
            self.cbShowLegS.Enable(True)
            self.tcInterval.Enable(True)
            self.tcInterval2.Enable(True)

        self.choiceLinkYG.Enable(not flgcommony)
        self.choiceLinkYP.Enable(not flgcommony)

        flglogs = self.panel.flglogs
        self.cbLogS.SetValue(flglogs)

        linky = self.panel.linky


        choices = self.graphinfo.getGroupChoices()
        choices = choices + ['Unlink']
        self.choiceLinkYG.SetItems(choices)
        if linky:
            grp, pnl = linky
            self.choiceLinkYG.SetSelection(grp.groupid)
            pchoices = self.graphinfo.getPanelChoices(grp)
            self.choiceLinkYP.SetItems(pchoices)
            self.choiceLinkYP.SetSelection(pnl.panelid)
        else:
            self.choiceLinkYG.SetSelection(len(choices)-1)
            self.choiceLinkYP.SetItems([])

    def OnResize(self, event):
        event.Skip()

    def OnLabelXYS(self, event=None):
        obj = event.GetEventObject()
        if obj == self.btnLabelX:
            label = self.panel.group.labelx
            label.setData(text = self.tcLabelX.GetValue())
        elif obj == self.btnLabelY:
            flg = self.cbCommonY.GetValue()
            if flg:
                label = self.panel.group.labely
            else:
                label = self.panel.labely
            label.setData(text = self.tcLabelY.GetValue())
        else:
            label = self.panel.labels
            label.setData(text = self.tcLabelS.GetValue())

        dialog = SetLabelDlg(self, label, self.graphinfo)
        result = dialog.ShowModal()
        if result == wx.ID_OK:
            dialogdata = dialog.GetResult()
            [text, family, style, weight, size, color, rotation, 
                    halign, valign] = dialogdata
            label.setData(
                    text = text,
                    fontfamily = family,
                    fontstyle =style,
                    fontweight = weight,
                    fontsize = size,
                    fontcolor = color,
                    rotation = rotation,
                    halignment = halign,
                    valignment = valign)
            if obj == self.btnLabelX:
                self.tcLabelX.SetValue("%s" % text)
            elif obj == self.btnLabelY:
                self.tcLabelY.SetValue("%s" % text)
            else:
                self.tcLabelS.SetValue("%s" % text)
        dialog.Destroy()

    def OnTickLabelXYS(self, event=None):
        obj = event.GetEventObject()
        if obj == self.btnX:
            ticklabel = self.panel.group.ticklabelx
        elif obj == self.btnY:
            flg = self.cbCommonY.GetValue()
            if flg:
                ticklabel = self.panel.group.ticklabely
            else:
                ticklabel = self.panel.ticklabely
        else:
            ticklabel = self.panel.ticklabels

        dialog = SetTickLabelDlg(self, ticklabel, self.graphinfo)
        result = dialog.ShowModal()
        if result == wx.ID_OK:
            dialogdata = dialog.GetResult()
            [fmt, family, style, weight, size, color, rotation, 
                    halign, valign, flgtrimfirst, flgtrimlast] = dialogdata
            ticklabel.setData(
                    fmt = fmt,
                    fontfamily = family,
                    fontstyle =style,
                    fontweight = weight,
                    fontsize = size,
                    fontcolor = color,
                    rotation = rotation,
                    halignment = halign,
                    valignment = valign,
                    flgtrimfirst = flgtrimfirst,
                    flgtrimlast = flgtrimlast)
        dialog.Destroy()

    def OnLegendStyleYS(self, event=None):
        obj = event.GetEventObject()
        if obj == self.btnLegendY:
            lstyle = self.panel.legendstyley
        else:
            lstyle = self.panel.legendstyles

        dialog = SetLabelStyleDlg(self, lstyle, self.graphinfo)
        result = dialog.ShowModal()
        if result == wx.ID_OK:
            dialogdata = dialog.GetResult()
            [family, style, weight, size] = dialogdata
            lstyle.setData(
                    fontfamily = family,
                    fontstyle =style,
                    fontweight = weight,
                    fontsize = size,
                    #fontcolor = color,
                    #rotation = rotation,
                    #halignment = halign,
                    #valignment = valign,
                    )
        dialog.Destroy()

    def GetResult(self):
        """
        設定した内容を配列で返す
        """
        xmin = float(self.tcXmin.GetValue())
        xmax = float(self.tcXmax.GetValue())
        ymin = float(self.tcYmin.GetValue())
        ymax = float(self.tcYmax.GetValue())
        smin = float(self.tcSmin.GetValue())
        smax = float(self.tcSmax.GetValue())
        if xmin > xmax:
            xmin, xmax = xmax, xmin
        if ymin > ymax:
            ymin, ymax = ymax, ymin
        if smin > smax:
            smin, smax = smax, smin

        interval = float(self.tcInterval.GetValue())
        interval2 = float(self.tcInterval2.GetValue())
        textx = self.tcLabelX.GetValue()
        texty = self.tcLabelY.GetValue()
        texts = self.tcLabelS.GetValue()
        flgcommony = self.cbCommonY.GetValue()
        flglogx = self.cbLogX.GetValue()
        flglogy = self.cbLogY.GetValue()
        flggrid = self.cbGridY.GetValue()
        flgshowlegy = self.cbShowLegY.GetValue()
        flglogs = self.cbLogS.GetValue()
        flgshowlegs = self.cbShowLegS.GetValue()
        if self.radioxy.GetValue():
            ptype = 0
        elif self.radioxy2.GetValue():
            ptype = 1
        else:
            ptype =2 

        linkidg = self.choiceLinkYG.GetSelection()
        linkidp = self.choiceLinkYP.GetSelection()

        if linkidg == len(self.choiceLinkYG.GetItems())-1:
            linkidg = -1
            linkidp = -1
        if flgcommony or linkidp == -1:
            linkidg = -1
            linkidp = -1
        return [xmin, xmax, flglogx, textx, 
                flgcommony, ymin, ymax, flglogy, flggrid, flgshowlegy, texty, 
                ptype, smin, smax, flglogs, flgshowlegs, texts, linkidg, linkidp, interval, interval2]

    def OnChoiceLinkYG(self, event=None):
        linkidg = self.choiceLinkYG.GetSelection()
        if linkidg == len(self.choiceLinkYG.GetItems())-1:
            linkidg = -1
        if -1 != linkidg:
            grp = self.graphinfo.groups[linkidg]
            pchoices = self.graphinfo.getPanelChoices(grp)
            self.choiceLinkYP.SetItems(pchoices)
        else:
            self.choiceLinkYP.SetItems([])
    
    def OnRadioButton(self, event=None):
        """
        plot type changed
        """
        if self.radioxy.GetValue():
            self.tcSmin.Enable(False)
            self.tcSmax.Enable(False)
            self.cbLogS.Enable(False)
            self.tcLabelS.Enable(False)
            self.btnLabelS.Enable(False)
            self.btnS.SetLabel("Y2: ")
            self.stLogS.SetLabel(":Log Scale Y2 ")
            self.btnLegendS.Enable(False)
            self.stLabelS.SetLabel("Label Y2")
            self.stShowLegS.SetLabel(":Show Legend ")
            self.cbShowLegS.Enable(False)
            self.tcInterval.Enable(False)
            self.tcInterval2.Enable(False)
        if self.radioxy2.GetValue():
            self.tcSmin.Enable(True)
            self.tcSmax.Enable(True)
            self.cbLogS.Enable(True)
            self.tcLabelS.Enable(True)
            self.btnLabelS.Enable(True)
            self.btnLegendS.Enable(True)
            self.btnS.SetLabel("Y2: ")
            self.stLogS.SetLabel(":Log Scale Y2 ")
            self.stLabelS.SetLabel("Label Y2")
            self.stShowLegS.SetLabel(":Show Legend Y2 ")
            self.cbShowLegS.Enable(True)
            self.tcInterval.Enable(False)
            self.tcInterval2.Enable(False)
        if self.radioxyz.GetValue():
            self.tcSmin.Enable(True)
            self.tcSmax.Enable(True)
            self.cbLogS.Enable(True)
            self.tcLabelS.Enable(True)
            self.btnLabelS.Enable(True)
            self.btnLegendS.Enable(True)
            self.btnS.SetLabel("Z: ")
            self.stLogS.SetLabel(":Log Scale Z ")
            self.stLabelS.SetLabel("Label Z")
            self.stShowLegS.SetLabel(":Show Legend Z ")
            self.cbShowLegS.Enable(True)
            self.tcInterval.Enable(True)
            self.tcInterval2.Enable(True)

    def OnCommonY(self, event=None):
        flg = self.cbCommonY.GetValue()
        self.choiceLinkYG.Enable(not flg)
        self.choiceLinkYP.Enable(not flg)
        if flg:
            self.ymin = self.panel.group.ymin
            self.ymax = self.panel.group.ymax
            self.tcYmin.SetValue("%g" % self.ymin)
            self.tcYmax.SetValue("%g" % self.ymax)
            self.tcLabelY.SetValue("%s" % self.panel.group.labely.text)
            flglogy = self.panel.group.flglogy
            self.cbLogY.SetValue(flglogy)
            flgshowlegy = self.panel.group.flgshowlegy
            self.cbShowLegY.SetValue(flgshowlegy)
        else:
            self.ymin = self.panel.ymin
            self.ymax = self.panel.ymax
            self.tcYmin.SetValue("%g" % self.ymin)
            self.tcYmax.SetValue("%g" % self.ymax)
            self.tcLabelY.SetValue("%s" % self.panel.labely.text)
            flglogy = self.panel.flglogy
            self.cbLogY.SetValue(flglogy)
            flgshowlegy = self.panel.flgshowlegy
            self.cbShowLegY.SetValue(flgshowlegy)

    def OnMin(self, event):
        event.Skip()
        tc = event.GetEventObject()
        if tc == self.tcXmin:
            vorg = self.xmin
            vmax = self.xmax
        elif tc == self.tcYmin:
            vorg = self.ymin
            vmax = self.ymax
        elif tc == self.tcSmin:
            vorg = self.smin
            vmax = self.smax
        sv = tc.GetValue()
        try:
            v = float(sv)
        except ValueError:
            tc.SetValue("%g" % vorg)
        self.xmin = float(self.tcXmin.GetValue())
        self.ymin = float(self.tcYmin.GetValue())

    def OnMax(self, event):
        event.Skip()
        tc = event.GetEventObject()
        if tc == self.tcXmax:
            vorg = self.xmax
            vmin = self.xmin
        elif tc == self.tcYmax:
            vorg = self.ymax
            vmin = self.ymin
        elif tc == self.tcSmax:
            vorg = self.smax
            vmin = self.smin
        sv = tc.GetValue()
        try:
            v = float(sv)
        except ValueError:
            tc.SetValue("%g" % vorg)
        self.xmax = float(self.tcXmax.GetValue())
        self.ymax = float(self.tcYmax.GetValue())
        
    def OnInterval(self, event):
        sv = self.tcInterval.GetValue()
        v = float(sv)
        self.tcInterval.SetValue("%g" % (v))
        self.interval = v

    def OnInterval2(self, event):
        sv = self.tcInterval2.GetValue()
        v = float(sv)
        self.tcInterval2.SetValue("%g" % (v))
        self.interval2 = v
        
    def OnQuit(self, evt=None):
        self.Close()

if __name__ == '__main__':
    from MyViewGraphInfo import *

    app = wx.App()

    graphinfo = GraphInfo()
    graphinfo.load('plot_default.txt')

    group = graphinfo.groups[0]
    panel = group.panels[0]

    dialog = SetPanelDlg(None, panel, graphinfo)
    result = dialog.ShowModal()
    if result == wx.ID_OK:
        dialogdata = dialog.GetResult()
        print(dialogdata)
    dialog.Destroy()


