#!/usr/bin/env python
# coding: utf-8
# $Id$

import wx
import wx.lib.newevent
import os
import re
import sys
import copy
from MyViewPresets import Presets
from MyViewGlobal import debug, logger
from MyViewDataInfo import DataInfo

class MyViewSetPresetDlg(wx.Dialog):
    """
    Mocule ウィンドウ
    """
    def SetPresets(self, presets):
        """
        プリセットのロード
        """
        self.lbPreset.DeleteAllItems()
        dic = presets.GetDict()
        for i, e in enumerate(dic):
            self.lbPreset.InsertStringItem(i, e)
            self.lbPreset.SetStringItem(i,1,dic[e])
            
    def SetSelected(self, event):
        no = self.lbPreset.GetFirstSelected()
        if ( no < 0 ):
            self.selected = None
        else:
            self.selected = str(self.lbPreset.GetItemText(no))
        self.EndModal(wx.ID_OK)

    def GetSelected(self):
        return self.selected

    def __init__(self, parent):
        wx.Dialog.__init__(self, parent, -1, 'Available Presets', 
                style=wx.DEFAULT_DIALOG_STYLE|wx.RESIZE_BORDER|wx.STAY_ON_TOP)
        #, 
        #        size=(480,250))


#        self.lbPreset = wx.ListBox(self, wx.ID_ANY, size=(200,200), style=wx.LB_ALWAYS_SB|wx.LB_SORT)
        self.lbPreset = wx.ListCtrl(self, wx.ID_ANY, size=(700,200), style=wx.LC_REPORT)
        self.lbPreset.InsertColumn(0, 'Name')
        self.lbPreset.InsertColumn(1, 'Description')
        self.lbPreset.SetColumnWidth(0,200)
        self.lbPreset.SetColumnWidth(1,600)
        self.selected = None

        fgsizer = wx.FlexGridSizer(rows=1, cols=1, hgap=5, vgap=5)
        fgsizer.AddGrowableCol(0)
        fgsizer.AddGrowableRow(0)

        fgsizer.Add(self.lbPreset, 0, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        btnOk = wx.Button(self, wx.ID_OK, "OK")
        btnCancel= wx.Button(self, wx.ID_CANCEL, "Cancel")
        btnOk.SetDefault()

        btnsizer = wx.BoxSizer(wx.HORIZONTAL)
        btnsizer.Add(btnOk, 1, wx.EXPAND)
        btnsizer.Add(btnCancel, 1, wx.EXPAND)

        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(fgsizer, 1, wx.EXPAND|wx.ALL)
        sizer.Add(btnsizer, 0,wx.ALIGN_CENTER, 5)

        self.SetSizer(sizer)
        self.Layout()
        self.Fit()

        self.Bind(wx.EVT_BUTTON, self.SetSelected, btnOk)

if __name__ == '__main__':
    presets = Presets()
    presets.PresetLoad('./presets/presets.txt')

    app = wx.PySimpleApp()

    dialog = MyViewSetPresetDlg(None)
    dialog.SetPresets(presets)
    result = dialog.ShowModal()
    if ( result == wx.ID_OK ):
        selected = dialog.GetSelected()
        print(('selected=',selected))

    dialog.Destroy()
