#!/usr/bin/env python
# coding: utf-8

import wx
import wx.lib.newevent

class SetProfileDlg(wx.Dialog):
    def __init__(self, parent, profile, current=None):
        wx.Dialog.__init__(self, parent, -1, 'Change Profile', 
                style=wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER|wx.STAY_ON_TOP)
        #self.SetBackgroundColour(wx.Colour(200, 200, 200))
        self.font = wx.Font(11, wx.MODERN, wx.NORMAL, wx.NORMAL, False)
        self.choice = current

        #------------
        st = wx.StaticText(self, -1, "Current Profile")
        self.choiceProfile = wx.Choice(self)
        for i,p in enumerate(profile.PROFILES.keys()):
            d = profile.PROFILES[p]['desc']
            self.choiceProfile.Append(d, p)
            if ( p == current ):
            	self.choiceProfile.SetSelection(i)
        
        btnOk = wx.Button(self, wx.ID_OK, "OK")
        btnOk.SetDefault()
        btnCancel= wx.Button(self, wx.ID_CANCEL, "Cancel")
        btnsizer = wx.BoxSizer(wx.HORIZONTAL)
        btnsizer.Add(btnOk, 1, wx.EXPAND)
        btnsizer.Add(btnCancel, 1, wx.EXPAND)
        
        sizer = wx.BoxSizer(wx.VERTICAL)
#        sizer.Add(self.panel, 1, wx.EXPAND|wx.ALL, 0)
        sizer.Add(st, 0, wx.EXPAND|wx.ALL, 5)
        sizer.Add(self.choiceProfile, 0, wx.EXPAND|wx.ALL, 5)
        sizer.Add(btnsizer, 1, wx.EXPAND|wx.ALL, 5)
        
        self.SetSizer(sizer)
        self.Fit()
        self.choiceProfile.Bind(wx.EVT_CHOICE, self.OnChoice)

        #self.panel.Bind(self.panel.LIST_ITEM_ACTIVATED, self.OnListItemActivated)
        
    def OnChoice(self, event):
        n = self.choiceProfile.GetSelection()
        self.choice = self.choiceProfile.GetClientData(n)

    def GetResult(self):
        return self.choice

if __name__ == '__main__':
    import MyViewProfile
    app = wx.App()
    profile = MyViewProfile.Profile()
    dialog = SetProfileDlg(None, profile,'lhd')
    result = dialog.ShowModal()
    choice = dialog.GetResult()
    print(choice)
    
    dialog.Destroy()

