#!/usr/bin/env python
# coding: utf-8
#$Id$

import matplotlib
matplotlib.use('WXAgg')
import wx
import wx.html
import wx_patch
import os
import re
import sys
from MyViewGraphInfo import *
from MyViewDataInfo import *
from MyViewColorButton import *
from MyViewColorMapPicker import *
from MyViewSetMoreModuleDlg import *
from MyViewGlobal import variables
from MyViewShowInfoDlg import *
import util
#from test import *
import EGSelectDlg

try:
    _dummy = wx.Colour
except NameError:
    wx.Colour = wx.Color

DefaultText = """
<p>Here is an expanation of this module <p><br>
Module name : modulename <br>
Script name : script.py <br>
Author name : the name of developer <br>
Contact to  : eg-support@nifs.ac.jp <br>
<br>
<p>Options<p><br>
ntavg : average in time <br>
ex) ntavg=20 <br>
this means 20 data points in time are averaged and produces one data point.<br>
"""


class HtmlWindow(wx.html.HtmlWindow):
    def __init__(self, parent, id, size=(600,400)):
        wx.html.HtmlWindow.__init__(self,parent, id, size=size)
        if "gtk2" in wx.PlatformInfo:
            self.SetStandardFonts()

    def OnLinkClicked(self, link):
        wx.LaunchDefaultBrowser(link.GetHref())

class AboutBox(wx.Dialog):
    def __init__(self, parent, htmltext):
        wx.Dialog.__init__(self, parent, -1, "About modulename",
            style=wx.DEFAULT_DIALOG_STYLE|wx.THICK_FRAME|wx.RESIZE_BORDER|
                wx.TAB_TRAVERSAL|wx.STAY_ON_TOP)
        hwin = HtmlWindow(self, -1, size=(400,200))
        hwin.SetPage(htmltext)
        btn = hwin.FindWindowById(wx.ID_OK)
        irep = hwin.GetInternalRepresentation()
        hwin.SetSize((irep.GetWidth()+25, irep.GetHeight()+10))
        self.SetClientSize(hwin.GetSize())
        self.CentreOnParent(wx.BOTH)
        self.SetFocus()

STAT_PAGE='http://egdb.lhd.nifs.ac.jp/dataexplog/registered_data.html'
class ErrorBox(wx.Dialog):
    def __init__(self, parent):
        config = variables['%CONFIG%']
        STAT_PAGE = str(config['statpage'])
        wx.Dialog.__init__(self, parent, -1, 'About myView', size=(400, 200))
        button = wx.Button(self, wx.ID_OK, "OK")
        message = wx.StaticText(self, -1,"The data is not found. Please visit the following URL To see if the data is available.\n")
        hc_url = wx.HyperlinkCtrl(self, wx.ID_ANY, STAT_PAGE, STAT_PAGE)

        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(message, 0, wx.EXPAND)
        #sizer.Add(message, 0, wx.EXPAND|wx.ALIGN_CENTER)
        sizer.Add(hc_url, 0, wx.ALIGN_CENTER)
        sizer.Add((20,20), 0, wx.ALIGN_CENTER)
        sizer.Add(button, 0, wx.ALIGN_CENTER)
        self.SetSizer(sizer)
        self.Layout()
        
        hc_url.Bind(wx.EVT_MOUSE_EVENTS, self.OnMouseEvent)

    def OnMouseEvent(self, event):
        event.Skip()
        if event.LeftUp():
            self.Close()


class SetTraceDlg(wx.Dialog):
    """
    トレース設定用ダイアログ
    """
    def __init__(self, parent, trace=None, graphinfo=None, datainfo=None, 
            colorpicker=None, partial=False):
        wx.Dialog.__init__(self, parent, -1, 'MyView2 Setup Trace', 
                style=wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER | wx.STAY_ON_TOP)
        #self.SetBackgroundColour(wx.Colour(200, 200, 200))
        self.font = wx.Font(11, wx.MODERN, wx.NORMAL, wx.NORMAL, False)
        self.colorpicker = colorpicker
        self.parent = parent
        self.trace = trace
        self.graphinfo = graphinfo
        self.datainfo = datainfo
        self.datainfotext = ""
        """
        do not change the values in self.panel and self.graphinfo inside this dialog
        after back to parent, the values in the panel should be changed if the dialog 
        return the wx.ID_OK.
        You can get the values in this dialog with calling dialog.getResult()  
        """

        stGroup = wx.StaticText(self, -1, "Group: ")
        stPanel = wx.StaticText(self, -1, "Panel: ")

        self.btnModuleName = wx.Button(self, -1, "Module: ")
       
        stDataID = wx.StaticText(self, -1, "Shot:")
        stX = wx.StaticText(self, -1, "X: ")
        stY = wx.StaticText(self, -1, "Y: ")
        stZ = wx.StaticText(self, -1, "Z: ")
        stIndex = wx.StaticText(self, -1, "Index: ")
        stOption = wx.StaticText(self, -1, "Option: ")
        stSymbol = wx.StaticText(self, -1, "Symbol: ")
        stSymbolSize = wx.StaticText(self, -1, "Size: ")
        stLineStyle = wx.StaticText(self, -1, "Style: ")
        stLineWidth = wx.StaticText(self, -1, "Width: ")
        stColor = wx.StaticText(self, -1, "Color: ")
        stColorMap = wx.StaticText(self, -1, "ColorMap: ")
        stFactor = wx.StaticText(self, -1, "Factor: ")
        stOffset = wx.StaticText(self, -1, "Offset: ")
        stXFactor = wx.StaticText(self, -1, "X: ")
        stXOffset = wx.StaticText(self, -1, "X: ")
        stYFactor = wx.StaticText(self, -1, "Y: ")
        stYOffset = wx.StaticText(self, -1, "Y: ")
        stZFactor = wx.StaticText(self, -1, "Z: ")
        stZOffset = wx.StaticText(self, -1, "Z: ")
        stType = wx.StaticText(self, -1, "Type: ")
        stShow = wx.StaticText(self, -1, "Show: ")
        self.btnColormap = wx.Button(self, -1, "")

        radiopanel = wx.Panel(self, -1)
        self.radioIDC = wx.RadioButton(radiopanel, -1, "Current", style=wx.RB_GROUP)
        self.radioIDR = wx.RadioButton(radiopanel, -1, "Ref") 
        self.radioIDA = wx.RadioButton(radiopanel, -1, "Add")
        self.tcIDA = wx.TextCtrl(radiopanel, -1, '', style=wx.TE_PROCESS_ENTER, size=(80,10))
        self.tcIDC = wx.TextCtrl(radiopanel, -1, '', style=wx.TE_PROCESS_ENTER, size=(80,10))
        self.tcIDR = wx.TextCtrl(radiopanel, -1, '', style=wx.TE_PROCESS_ENTER, size=(80,10))
        self.btnIDA = wx.Button(radiopanel, -1, 'F')
        radiosizer = wx.BoxSizer(wx.HORIZONTAL)
        radiosizer.Add(self.radioIDC, 0, wx.ALL, 5)
        radiosizer.Add(self.tcIDC, 1, wx.EXPAND|wx.ALL, 5)
        radiosizer.Add(self.radioIDR, 0, wx.ALL, 5)
        radiosizer.Add(self.tcIDR, 1, wx.EXPAND|wx.ALL, 5)
        radiosizer.Add(self.radioIDA, 0, wx.ALL, 5)
        radiosizer.Add(self.tcIDA, 1, wx.EXPAND|wx.ALL, 5)
        radiosizer.Add(self.btnIDA, 0, wx.ALL, 5)
        radiopanel.SetSizer(radiosizer)
        radiopanel.Fit()

        radiopanel2 = wx.Panel(self, -1)
        self.radioXY = wx.RadioButton(radiopanel2, -1, "X-Y", style=wx.RB_GROUP)
        self.radioXY2 = wx.RadioButton(radiopanel2, -1, "X-Y2") 
        self.radioXYZ = wx.RadioButton(radiopanel2, -1, "XYZ")
        radio2sizer = wx.BoxSizer(wx.HORIZONTAL)
        radio2sizer.Add(self.radioXY, 0, wx.ALL, 5)
        radio2sizer.Add(self.radioXY2, 0, wx.ALL, 5)
        radio2sizer.Add(self.radioXYZ, 0, wx.ALL, 5)
        radiopanel2.SetSizer(radio2sizer)
        radiopanel2.Fit()


        self.choiceGroup = wx.Choice(self, -1, choices=[])
        self.choicePanel = wx.Choice(self, -1, choices=[])
#        self.choiceModuleName = wx.Choice(self, -1, choices=[])
        #self.tcText = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.choiceX = wx.Choice(self, -1, choices=[])
        self.choiceY = wx.Choice(self, -1, choices=[])
        self.choiceZ = wx.Choice(self, -1, choices=[])
        self.comboIndex = wx.ComboBox(self, -1, choices=[], style=wx.TE_PROCESS_ENTER)
        self.tcOption = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.comboSymbol = wx.ComboBox(self, -1, choices=[])
        self.comboSymbolSize = wx.ComboBox(self, -1, choices=[])
        self.comboLineStyle = wx.ComboBox(self, -1, choices=[])
        self.comboLineWidth = wx.ComboBox(self, -1, choices=[])
        self.color = "#%02X%02X%02X" % (255, 0, 0)
        self.btnColor = ColorButton(self, self.color, self.colorpicker)
        self.tcXFactor = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcXOffset = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcFactor = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcOffset = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcZFactor = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.tcZOffset = wx.TextCtrl(self, -1, '', style=wx.TE_PROCESS_ENTER)
        self.cbShow = wx.CheckBox(self, -1, '', style=wx.TE_PROCESS_ENTER)
       
        modulepanel = wx.Panel(self, -1)
        self.btnMore = wx.Button(modulepanel, -1, "more modules")
        self.btnEGData = wx.Button(modulepanel, -1, "EG Data")
        self.choiceModuleName = wx.Choice(modulepanel, -1, choices=[])
        modulesizer = wx.BoxSizer(wx.HORIZONTAL)
        modulesizer.Add(self.choiceModuleName, 0, wx.ALL, 5)
        modulesizer.Add(self.btnMore, 0, wx.ALL, 5)
        modulesizer.Add(self.btnEGData, 0, wx.ALL, 5)
        modulepanel.SetSizer(modulesizer)
        modulepanel.Fit()
        
        btnDataInfo = wx.Button(self, -1, "Data Informations")
        
        factorsizer = wx.BoxSizer(wx.HORIZONTAL)
        factorsizer.Add(stXFactor, 0, wx.ALL, 2)
        factorsizer.Add(self.tcXFactor, 1, wx.EXPAND|wx.ALL, 2)
        factorsizer.Add(stYFactor, 0, wx.ALL, 2)
        factorsizer.Add(self.tcFactor, 1, wx.EXPAND|wx.ALL, 2)
        factorsizer.Add(stZFactor, 0, wx.ALL, 2)
        factorsizer.Add(self.tcZFactor, 1, wx.EXPAND|wx.ALL, 2)
        
        offsetsizer = wx.BoxSizer(wx.HORIZONTAL)
        offsetsizer.Add(stXOffset, 0, wx.ALL, 2)
        offsetsizer.Add(self.tcXOffset, 1, wx.EXPAND|wx.ALL, 2)
        offsetsizer.Add(stYOffset, 0, wx.ALL, 2)
        offsetsizer.Add(self.tcOffset, 1, wx.EXPAND|wx.ALL, 2)
        offsetsizer.Add(stZOffset, 0, wx.ALL, 2)
        offsetsizer.Add(self.tcZOffset, 1, wx.EXPAND|wx.ALL, 2)

        num_items = 20
        fgsizer = wx.FlexGridSizer(rows=num_items, cols=3, hgap=5, vgap=5)
        fgsizer.AddGrowableCol(2)
        self.SetItemInSizerWithChecks(fgsizer,
                (('groupid', stGroup, self.choiceGroup),
                 ('panelid', stPanel, self.choicePanel),
#                 ('modulename', self.btnModuleName, self.choiceModuleName),
                 ('modulename', self.btnModuleName, modulepanel),
                 ('dataidc', stDataID, radiopanel),
                 ('nocheck', None, btnDataInfo),
                 ('varx', stX, self.choiceX),
                 ('vary', stY, self.choiceY),
                 ('varz', stZ, self.choiceZ),
                 ('index', stIndex, self.comboIndex),
                 ('option', stOption, self.tcOption),
                 ('symbol', stSymbol, self.comboSymbol),
                 ('symbolsize', stSymbolSize, self.comboSymbolSize),
                 ('linestyle', stLineStyle, self.comboLineStyle),
                 ('linewidth', stLineWidth, self.comboLineWidth),
                 ('color', stColor, self.btnColor),
                 ('cmapname', stColorMap, self.btnColormap),
                 #('offset', stOffset, self.tcOffset),
                 #('factor', stFactor, self.tcFactor),
                 ('offset', stOffset, offsetsizer),
                 ('factor', stFactor, factorsizer),
                 ('plottype', stType, radiopanel2),
                 ('flgshow', stShow,  self.cbShow)))

        for cb in list(self.checks_dic.values()):
            cb.SetValue(not partial)
            cb.Enable(partial)

        btnOk = wx.Button(self, wx.ID_OK, "OK")
        btnOk.SetDefault()
        btnCancel= wx.Button(self, wx.ID_CANCEL, "Cancel")
        btnsizer = wx.BoxSizer(wx.HORIZONTAL)
        btnsizer.Add(btnOk, 1, wx.EXPAND)
        btnsizer.Add(btnCancel, 1, wx.EXPAND)
        
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(fgsizer, 0, wx.EXPAND|wx.ALL)
        sizer.Add(btnsizer, 0, wx.EXPAND|wx.ALL, 5)
        
        self.SetSizer(sizer)
        self.Fit()

        self.Bind(wx.EVT_BUTTON, self.OnModuleName, self.btnModuleName)
        self.Bind(wx.EVT_BUTTON, self.OnBtnIDA, self.btnIDA)
        self.Bind(wx.EVT_BUTTON, self.OnColormap, self.btnColormap)
        self.Bind(wx.EVT_BUTTON, self.OnMore, self.btnMore)
        self.Bind(wx.EVT_BUTTON, self.OnEGData, self.btnEGData)
        self.Bind(wx.EVT_BUTTON, self.OnDataInfo, btnDataInfo)
        self.Bind(wx.EVT_SIZE, self.OnResize, self)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioButton, self.radioIDC)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioButton, self.radioIDR)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioButton, self.radioIDA)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioButtonType, self.radioXY)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioButtonType, self.radioXY2)
        self.Bind(wx.EVT_RADIOBUTTON, self.OnRadioButtonType, self.radioXYZ)
        self.Bind(wx.EVT_CHOICE, self.OnChoiceGroup, self.choiceGroup)
        self.Bind(wx.EVT_CHOICE, self.OnChoice, self.choiceX)
        self.Bind(wx.EVT_CHOICE, self.OnChoice, self.choiceY)
        self.Bind(wx.EVT_CHOICE, self.OnChoice, self.choiceZ)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnIndex, self.comboIndex)
        self.comboIndex.Bind(wx.EVT_KILL_FOCUS, self.OnIndex, self.comboIndex)
        self.tcOption.Bind(wx.EVT_TEXT_ENTER, self.OnChoice, self.tcOption)
        self.tcOption.Bind(wx.EVT_KILL_FOCUS, self.OnChoice, self.tcOption)
        self.tcOffset.Bind(wx.EVT_TEXT_ENTER, self.OnOffset, self.tcOffset)
        self.tcOffset.Bind(wx.EVT_KILL_FOCUS, self.OnOffset, self.tcOffset)
        self.tcFactor.Bind(wx.EVT_TEXT_ENTER, self.OnFactor, self.tcFactor)
        self.tcFactor.Bind(wx.EVT_KILL_FOCUS, self.OnFactor, self.tcFactor)
        self.tcXOffset.Bind(wx.EVT_TEXT_ENTER, self.OnXOffset, self.tcXOffset)
        self.tcXOffset.Bind(wx.EVT_KILL_FOCUS, self.OnXOffset, self.tcXOffset)
        self.tcXFactor.Bind(wx.EVT_TEXT_ENTER, self.OnXFactor, self.tcXFactor)
        self.tcXFactor.Bind(wx.EVT_KILL_FOCUS, self.OnXFactor, self.tcXFactor)
        self.tcZOffset.Bind(wx.EVT_TEXT_ENTER, self.OnZOffset, self.tcZOffset)
        self.tcZOffset.Bind(wx.EVT_KILL_FOCUS, self.OnZOffset, self.tcZOffset)
        self.tcZFactor.Bind(wx.EVT_TEXT_ENTER, self.OnZFactor, self.tcZFactor)
        self.tcZFactor.Bind(wx.EVT_KILL_FOCUS, self.OnZFactor, self.tcZFactor)
        self.tcIDR.Bind(wx.EVT_TEXT_ENTER, self.OnIDR, self.tcIDR)
        self.tcIDR.Bind(wx.EVT_KILL_FOCUS, self.OnIDR, self.tcIDR)
        self.tcIDA.Bind(wx.EVT_TEXT_ENTER, self.OnIDA, self.tcIDA)
        self.tcIDA.Bind(wx.EVT_KILL_FOCUS, self.OnIDA, self.tcIDA)
        self.Bind(wx.EVT_CHOICE, self.OnChoiceModuleName, self.choiceModuleName)

        
        self.SetStateFirst()


    def SetItemInSizerWithChecks(self, sizer, lst_items):
        self.checks_dic = {}
        for items in lst_items:
            if items[0] == 'nocheck':
                sizer.Add((10, 10), 0, wx.ALIGN_CENTER_VERTICAL)
            else:
                check = wx.CheckBox(self, -1, '')
                sizer.Add(check, 1, wx.ALIGN_CENTER_VERTICAL)
                self.checks_dic[items[0]] = check
            for item in items[1:]:
                if item is not None:
                    sizer.Add(item, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
                else:
                    sizer.Add((10, 10), 0, wx.ALIGN_CENTER_VERTICAL)

    def SetStateFirst(self):
        """
        Setup the value of widgets on this dialog 
        by referencing with self.group and self.graphinfo.
        """
        groupid = self.trace.panel.group.groupid
        group = self.graphinfo.groups[groupid]
        choices = self.graphinfo.getGroupChoices()
        self.choiceGroup.SetItems(choices)
        self.choiceGroup.SetSelection(groupid)
        panelid = self.trace.panel.panelid
        choices = self.graphinfo.getPanelChoices(group)
        self.choicePanel.SetItems(choices)
        self.choicePanel.SetSelection(panelid)
        
        #------------------------
        choices = self.datainfo.getEnabledDataModuleChoices()
        self.choiceModuleName.SetItems(choices)
        modulename = self.trace.modulename
        if modulename in choices:
            self.choiceModuleName.SetSelection(choices.index(modulename))
        else:
            if len(choices) == 0:
                modulename = ""
            else:
                modulename = choices[0]
                self.choiceModuleName.SetSelection(0)
        #------------------------
        dataidc = self.trace.dataidc
        if 'C' == dataidc.upper():
            self.radioIDC.SetValue(True)
            self.tcIDA.Enable(False)
            self.tcIDR.Enable(False)
            self.tcIDC.Enable(False)
            self.btnIDA.Enable(False)
        elif 'R' == dataidc.upper():
            self.radioIDR.SetValue(True)
            self.tcIDA.Enable(False)
            self.tcIDR.Enable(True)
            self.tcIDC.Enable(False)
            self.btnIDA.Enable(False)
        else:
            self.radioIDA.SetValue(True)
            self.tcIDA.Enable(True)
            self.tcIDR.Enable(False)
            self.tcIDC.Enable(False)
            self.btnIDA.Enable(True)
            self.tcIDA.SetValue("%s" % dataidc)
        self.tcIDR.SetValue("%s" % self.graphinfo.dataid_ref)
        self.tcIDC.SetValue("%s" % self.graphinfo.dataid)
        #---------------------
        plottype = self.trace.plottype
        if plottype == 'xy':
            self.radioXY.SetValue(True)
            self.choiceZ.Enable(False)
            self.btnColormap.Enable(False)
        elif plottype == 'xy2':
            self.radioXY2.SetValue(True)
            self.choiceZ.Enable(False)
            self.btnColormap.Enable(False)
        elif plottype == 'xyz':
            self.radioXYZ.SetValue(True)
            self.choiceZ.Enable(True)
            self.btnColormap.Enable(True)
        #------------------------
        dataidc = self.trace.dataidc
        if dataidc.upper() == 'C':
            dataid = self.graphinfo.dataid
        elif dataidc.upper() == 'R':
            dataid = self.graphinfo.dataid_ref
        else:
            shot, subshot, rshot, rsubshot = util.ShotStringToInteger(
                    self.graphinfo.dataid,
                    self.graphinfo.dataid_ref)
            dataid = self.tcIDA.GetValue()
            dataid = util.ReplaceShotnumberInFilename(
                    dataid, shot, subshot, rshot, rsubshot)
        varx = self.trace.varx
        vary = self.trace.vary
        varz = self.trace.varz
        index = self.trace.index
        option = self.trace.option
        self.graphinfo.args['varx'] = varx
        self.graphinfo.args['vary'] = vary
        self.graphinfo.args['varz'] = varz
        self.graphinfo.args['type'] = plottype
        #--------------------- DataInfoText
        self.datainfotext = self.datainfo.getDataInfo(modulename, dataid, option, 
            **self.graphinfo.args)
        #--------------------- Var X
        choices = self.datainfo.getDataVarsX(modulename, dataid, option, 
            **self.graphinfo.args)
        self.choiceX.SetItems(choices)
        if varx in choices:
            self.choiceX.SetSelection(choices.index(varx))
        else:
            self.choiceX.SetSelection(0)
        #--- set initial varx --- 
        idx = self.choiceX.GetSelection()
        if idx != -1 and idx < len(choices):
            varx = choices[idx]
            self.graphinfo.args['varx'] = varx
        #--------------------- Var Y
        choices = self.datainfo.getDataVarsY(modulename, dataid, option, 
            **self.graphinfo.args)
        self.choiceY.SetItems(choices)
        if vary in choices:
            self.choiceY.SetSelection(choices.index(vary))
        else:
            self.choiceY.SetSelection(0)
        #--- set initial vary --- 
        idx = self.choiceY.GetSelection()
        if idx != -1 and idx < len(choices):
            vary = choices[idx]
            self.graphinfo.args['vary'] = vary
        #--------------------- Var Z
        choices = self.datainfo.getDataVarsZ(modulename, dataid, option, 
            **self.graphinfo.args)
        self.choiceZ.SetItems(choices)
        if varz in choices:
            self.choiceZ.SetSelection(choices.index(varz))
        else:
            self.choiceZ.SetSelection(0)
        #--- set initial varz --- 
        idx = self.choiceZ.GetSelection()
        if idx != -1 and idx < len(choices):
            varz = choices[idx]
            self.graphinfo.args['varz'] = varz
        #---------------------
        #print ">>>>>> varx=%s vary=%s varz=%s" % (varx, vary, varz)
        choices = self.datainfo.getDataIndexs(modulename, dataid, option, 
            varx=varx, vary=vary, varz=varz, type=plottype)
        self.comboIndex.SetItems(choices)
        self.comboIndex.SetValue(index)
        self.indexchoices = choices
        self.index = index
        #---------------------
        self.tcOption.SetValue("%s" % option)
        #---------------------
        symbol = self.trace.symbol
        choices = SymbolSet
        self.comboSymbol.SetItems(choices)
        self.comboSymbol.SetValue(symbol)
        #---------------------
        symbolsize = self.trace.symbolsize
        choices = SymbolSizeSet
        self.comboSymbolSize.SetItems(choices)
        self.comboSymbolSize.SetValue(symbolsize)
        #---------------------
        linestyle = self.trace.linestyle
        choices = LineStyleSet
        self.comboLineStyle.SetItems(choices)
        self.comboLineStyle.SetValue(linestyle)
        #---------------------
        linewidth = self.trace.linewidth
        choices = LineWidthSet
        self.comboLineWidth.SetItems(choices)
        self.comboLineWidth.SetValue(linewidth)
        #---------------------
        self.color = self.trace.color
        self.btnColor.set_color(self.color)
        #---------------------
        self.offset = self.trace.offset
        self.tcOffset.SetValue("%g" % self.offset)
        #---------------------
        self.factor = self.trace.factor
        self.tcFactor.SetValue("%g" % self.factor)
        #---------------------
        self.xoffset = self.trace.xoffset
        self.tcXOffset.SetValue("%g" % self.xoffset)
        #---------------------
        self.xfactor = self.trace.xfactor
        self.tcXFactor.SetValue("%g" % self.xfactor)
        #---------------------
        self.zoffset = self.trace.zoffset
        self.tcZOffset.SetValue("%g" % self.zoffset)
        #---------------------
        self.zfactor = self.trace.zfactor
        self.tcZFactor.SetValue("%g" % self.zfactor)
        #---------------------
        flgshow = self.trace.flgshow
        self.cbShow.SetValue(flgshow)

        cmap = self.trace.cmap
        if (plottype == 'xyz'):
            if (cmap in COLORMAPS_DIC):
                self.cmap = cmap
            else:
                self.cmap = COLORMAPS[0]
        else:
            self.cmap = ''
        self.btnColormap.SetLabel(self.cmap)

    def ResetVars(self):
        #------------------------
        idx = self.choiceModuleName.GetSelection()
        if idx == -1: return
        choices = self.choiceModuleName.GetItems()
        modulename = choices[idx]
        #------------------------
        self.WaitCursor(True)
        #------------------------
        if self.radioIDC.GetValue():
            dataid = self.graphinfo.dataid 
        elif self.radioIDR.GetValue():
            dataid = self.graphinfo.dataid_ref 
        else:
            shot, subshot, rshot, rsubshot = util.ShotStringToInteger(
                    self.graphinfo.dataid,
                    self.graphinfo.dataid_ref)
            dataid = self.tcIDA.GetValue()
            dataid = util.ReplaceShotnumberInFilename(dataid, shot, subshot, rshot, rsubshot)
        idx = self.choiceX.GetSelection()
        choices = self.choiceX.GetItems()
        if idx != -1:
            varx = choices[idx]
        else:
            varx = ""
        idx = self.choiceY.GetSelection()
        choices = self.choiceY.GetItems()
        if idx != -1:
            vary = choices[idx]
        else:
            vary = ""
        idx = self.choiceZ.GetSelection()
        choices = self.choiceZ.GetItems()
        if idx != -1:
            varz = choices[idx]
        else:
            varz = ""
        option = self.tcOption.GetValue()
        index = self.comboIndex.GetValue()
        
        #---------------------
        plottype = self.trace.plottype
        if self.radioXY.GetValue():
            plottype = 'xy'
        elif self.radioXY2.GetValue():
            plottype = 'xy2'
        elif self.radioXYZ.GetValue():
            plottype = 'xyz'

        self.graphinfo.args['varx'] = varx
        self.graphinfo.args['vary'] = vary
        self.graphinfo.args['varz'] = varz
        self.graphinfo.args['type'] = plottype
        self.datainfotext = self.datainfo.getDataInfo(modulename, dataid, option, 
            **self.graphinfo.args)
        choices = self.datainfo.getDataVarsX(modulename, dataid, option, 
            **self.graphinfo.args)
        self.choiceX.SetItems(choices)
        if varx in choices:
            self.choiceX.SetSelection(choices.index(varx))
        else:
            self.choiceX.SetSelection(0)
            self.graphinfo.args['varx'] = choices[0] if len(choices) > 0 else varx
        
        choices = self.datainfo.getDataVarsY(modulename, dataid, option, 
            **self.graphinfo.args)
        self.choiceY.SetItems(choices)
        if vary in choices:
            self.choiceY.SetSelection(choices.index(vary))
        else:
            self.choiceY.SetSelection(0)
            self.graphinfo.args['vary'] = choices[0] if len(choices) > 0 else vary

        choices = self.datainfo.getDataVarsZ(modulename, dataid, option, 
            **self.graphinfo.args)
        self.choiceZ.SetItems(choices)
        if varz in choices:
            self.choiceZ.SetSelection(choices.index(varz))
        else:
            self.choiceZ.SetSelection(0)
            self.graphinfo.args['varz'] = choices[0] if len(choices) > 0 else varz

        choices = self.datainfo.getDataIndexs(modulename, dataid, option, 
            **self.graphinfo.args)
        #print 'modulename=%s dataid=%s option=%s' % (modulename, dataid, option)
        self.comboIndex.SetItems(choices)
        self.comboIndex.SetValue(index)
        self.indexchoices = choices
        self.CorrectIndex()

        choices = self.choiceX.GetItems()
        if ( len(choices) == 0 ):
            dlg = ErrorBox(self)
            dlg.ShowModal()
            dlg.Destroy()
            

        #------------------------
        self.WaitCursor(False)
        #------------------------

    def CorrectIndex(self):
        """
        インデックス修正
        """
        if 0 == len(self.indexchoices):
            return
        vstr = self.comboIndex.GetValue()
        if vstr in self.indexchoices:
            return
        fmt = re.compile(r'(.*)_([0-9]*\.*[0-9]*e*[\+|\-]{0,1}[0-9]*).*')
        m = fmt.match(vstr)
        if m:
            try:
                idx = int(m.groups()[0])
            except ValueError:
                idx = 0
        else:
            idx = 0
        if idx < len(self.indexchoices):
            self.comboIndex.SetValue(self.indexchoices[idx])
        else:
            self.comboIndex.SetValue(self.indexchoices[0])

    def OnIndex(self, event=None):
        """
        Index のコールバック
        """
        event.Skip()
        if 0 == len(self.indexchoices):
            return
        #fmt = re.compile(r'(.*)_([0-9]*\.*[0-9]*).*')
        fmt = re.compile(r'(.*)_([0-9]*\.*[0-9]*e*[\+|\-]{0,1}[0-9]*).*')
        list_idxf = []
        list_idxv = []
        for idx in self.indexchoices:
            m = fmt.match(idx)
            if m:
                list_idxf.append(m.groups()[0])
                try:
                    vd = float(m.groups()[1])
                    list_idxv.append(vd)
                except ValueError:
                    pass
        vstr = self.comboIndex.GetValue()
        #self.indexchoices
        if vstr in self.indexchoices:
            return
        elif vstr in list_idxf:
            idx = list_idxf.index(vstr)
        else:
            try:
                v0 = float(vstr)
            except ValueError:
                v0 = None
            
            if v0 and 0 != len(list_idxv):
                list_d = [abs(v0 - v) for v in list_idxv]
                idx = list_d.index(min(list_d))
            else:
                idx = None
        if idx is not None:
            self.comboIndex.SetValue(self.indexchoices[idx])
            self.index = self.indexchoices[idx]
        else:
            self.comboIndex.SetValue(self.index)

    def OnModuleName(self, event=None):
        """
        Module ボタンのコールバック
        """
        choices = self.choiceModuleName.GetItems()
        idx = self.choiceModuleName.GetSelection()
        if idx != -1:
            modulename = choices[idx]
        else:
            modulename = None
        if modulename:
            htmltext = self.datainfo.getDataModuleHelp(modulename)
            if not htmltext:
                htmltext = DefaultText
        else:
            htmltext = DefaultText
        dlg = AboutBox(self, htmltext)
        dlg.ShowModal()
        dlg.Destroy()

    def OnResize(self, event):
        event.Skip()

    def OnChoiceGroup(self, event):
        """
        Group のコールバック
        """
        event.Skip()
        groupid = self.choiceGroup.GetSelection()
        group = self.graphinfo.groups[groupid]
        choices = self.graphinfo.getPanelChoices(group)
        self.choicePanel.SetItems(choices)
        self.choicePanel.SetSelection(0)

    def OnChoiceModuleName(self, event=None):
        """
        モジュール選択時
        """
        if event:
            event.Skip()
        self.radioIDC.SetValue(True)
        self.radioIDA.SetValue(False)
        self.tcIDA.Enable(False)
        self.tcIDR.Enable(False)
        self.tcIDC.Enable(True)
        self.btnIDA.Enable(False)
        self.tcIDA.SetValue("")
        self.tcIDR.SetValue("%s" % self.graphinfo.dataid_ref)
        self.tcIDC.SetValue("%s" % self.graphinfo.dataid)
        self.ResetVars()

    def OnChoice(self, event):
        event.Skip()
        self.ResetVars()

        
    def OnBtnIDA(self, event=None):
        """
        ID / Any 選択時
        """
        wildcard = "text file (*.txt) | *.txt|" \
                "All files (*.*)|*.*"
        dialog = wx.FileDialog(self, "Input filename", os.getcwd(),
                "", wildcard, wx.OPEN)
        result = dialog.ShowModal()
        if result == wx.ID_OK:
            filepath = dialog.GetPath()
        dialog.Destroy()
        if result == wx.ID_OK:
            self.tcIDA.SetValue(filepath)
            self.ResetVars()

    def OnColormap(self, event=None):
        """
        Color Map 選択時
        """

        dialog = ColorMapPickerDlg(self, self.cmap)
        result = dialog.ShowModal()
        if result == wx.ID_OK:
            self.cmap = dialog.GetResult()
            self.btnColormap.SetLabel(self.cmap)
        dialog.Destroy()

    def OnRadioButton(self, event=None):
        """
        DataID のコールバック
        """
        if self.radioIDA.GetValue(): # Any
            self.btnIDA.Enable(True)
            self.tcIDA.Enable(True)
            self.tcIDC.Enable(False)
            self.tcIDR.Enable(False)
            dataid = self.tcIDA.GetValue()

        elif self.radioIDR.GetValue():
            self.tcIDA.Enable(False)
            self.tcIDC.Enable(False)
            self.tcIDR.Enable(True)
            self.btnIDA.Enable(False)
            dataid = self.tcIDR.GetValue()
        else:
            self.tcIDA.Enable(False)
            self.tcIDC.Enable(True)
            self.tcIDR.Enable(False)
            self.btnIDA.Enable(False)
            dataid = self.tcIDC.GetValue()
        
        if dataid != "":
            self.ResetVars()

    def OnRadioButtonType(self, event=None):
        """
        Type のコールバック
        """
        if self.radioXY.GetValue():
            self.choiceZ.Enable(False)
            self.btnColormap.Enable(False)
        elif self.radioXY2.GetValue():
            self.choiceZ.Enable(False)
            self.btnColormap.Enable(False)
        else:
            self.choiceZ.Enable(True)
            if (self.cmap not in COLORMAPS_DIC):
                self.cmap = COLORMAPS[0]
            self.btnColormap.SetLabel(self.cmap)
            self.btnColormap.Enable(True)
        self.ResetVars()

    def OnDataInfo(self, event=None):
        event.Skip()
        dialog = ShowInfoDlg(self, contents_text=self.datainfotext)
        result = dialog.ShowModal()
        dialog.Destroy()

    def OnFactor(self, event=None):
        """
        Factorフィールドのコールバック
        """
        event.Skip()
        vstr = self.tcFactor.GetValue()
        try:
            factor = float(vstr)
        except (ValueError):
            factor = self.factor
        self.factor = factor
        self.tcFactor.SetValue("%g" % self.factor)

    def OnXFactor(self, event=None):
        """
        XFactorフィールドのコールバック
        """
        event.Skip()
        vstr = self.tcXFactor.GetValue()
        try:
            xfactor = float(vstr)
        except (ValueError):
            xfactor = self.xfactor
        self.xfactor = xfactor
        self.tcXFactor.SetValue("%g" % self.xfactor)
    
    def OnZFactor(self, event=None):
        """
        ZFactorフィールドのコールバック
        """
        event.Skip()
        vstr = self.tcZFactor.GetValue()
        try:
            zfactor = float(vstr)
        except (ValueError):
            zfactor = self.zfactor
        self.zfactor = zfactor
        self.tcZFactor.SetValue("%g" % self.zfactor)

    def OnOffset(self, event=None):
        """
        Offset フィールドのコールバック
        """
        event.Skip()
        vstr = self.tcOffset.GetValue()
        try:
            offset = float(vstr)
        except (ValueError):
            offset = self.offset
        self.offset = offset
        self.tcOffset.SetValue("%g" % self.offset)

    def OnXOffset(self, event=None):
        """
        XOffset フィールドのコールバック
        """
        event.Skip()
        vstr = self.tcXOffset.GetValue()
        try:
            xoffset = float(vstr)
        except (ValueError):
            xoffset = self.xoffset
        self.xoffset = xoffset
        self.tcXOffset.SetValue("%g" % self.xoffset)

    def OnZOffset(self, event=None):
        """
        ZOffset フィールドのコールバック
        """
        event.Skip()
        vstr = self.tcZOffset.GetValue()
        try:
            zoffset = float(vstr)
        except (ValueError):
            zoffset = self.zoffset
        self.zoffset = zoffset
        self.tcZOffset.SetValue("%g" % self.zoffset)

    def OnIDR(self, event=None):
        event.Skip()
        """
        RefID の入力が確定したときの処理
        """
        try:
            self.parent.SetRefID(self.tcIDR.GetValue())
            self.ResetVars()
        except AttributeError:
            pass
    
    def OnIDA(self, event=None):
        event.Skip()
        """
        AddID の入力が確定したときの処理
        """
        try:
            self.ResetVars()
        except AttributeError:
            pass
        
    def GetResult(self):
        """
        ダイアログの設定項目の取得
        """
        groupid = self.choiceGroup.GetSelection()
        panelid = self.choicePanel.GetSelection()
        choices = self.choiceModuleName.GetItems()
        idx = self.choiceModuleName.GetSelection()
        if idx != -1:
            modulename = choices[idx]
        else:
            modulename = None
        if self.radioIDC.GetValue():
            dataidc = 'C'
        elif self.radioIDR.GetValue():
            dataidc = "R"
            #try:
            #    self.parent.SetRefID(self.tcIDR.GetValue())
            #    print "Success"
            #except AttributeError:
            #    print "AttributeError"
                    
        else:
            dataidc = self.tcIDA.GetValue()

        choices = self.choiceX.GetItems()
        idx = self.choiceX.GetSelection()
        if idx != -1:
            varx = choices[idx]
        else:
            varx = ""
        choices = self.choiceY.GetItems()
        idx = self.choiceY.GetSelection()
        if idx != -1:
            vary = choices[idx]
        else:
            vary = ""
        choices = self.choiceZ.GetItems()
        idx = self.choiceZ.GetSelection()
        if idx != -1:
            varz = choices[idx]
        else:
            varz = ""
        choices = self.comboIndex.GetItems()
        index = self.comboIndex.GetValue()

        option = self.tcOption.GetValue()
        symbol = self.comboSymbol.GetValue()
        symbolsize = self.comboSymbolSize.GetValue()
        linestyle = self.comboLineStyle.GetValue()
        linewidth = self.comboLineWidth.GetValue()
        color = self.btnColor.get_color()
        #color = self.color
        offset = float(self.tcOffset.GetValue())
        factor = float(self.tcFactor.GetValue())
        xoffset = float(self.tcXOffset.GetValue())
        xfactor = float(self.tcXFactor.GetValue())
        zoffset = float(self.tcZOffset.GetValue())
        zfactor = float(self.tcZFactor.GetValue())
        flgshow = self.cbShow.GetValue()
        if self.radioXY.GetValue():
            plottype = 'xy'
            cmap = ''
        elif self.radioXY2.GetValue():
            plottype = 'xy2'
            cmap = ''
        else:
            plottype = 'xyz'
            cmap = self.btnColormap.GetLabel()

        checks = {}
        for k, v in list(self.checks_dic.items()):
            checks[k] = v.GetValue()

        return ((groupid, panelid, modulename, dataidc,
                varx, vary, varz, index, option, plottype, 
                symbol, symbolsize, linestyle, linewidth, color,
                factor, offset, flgshow, cmap, xfactor, xoffset, zfactor, zoffset), checks)

    def OnMore(self, event=None):
        dialog = MyViewSetMoreModuleDlg(self)
        modules = self.datainfo.datamodules.GetDataModules()
        disables = self.datainfo.datamodules.GetDisabledModules()
        synopses = [self.datainfo.getDataModuleSynopsis(e) for e in modules]
        dialog.SetModules(modules, disables, synopses)
        result = dialog.ShowModal()
        if ( result == wx.ID_OK ):
            selected = dialog.GetSelected()
            if selected:
                self.datainfo.datamodules.AddEnabledModules([selected])
                self.datainfo.datamodules.EnabledModuleSave()
                choices = self.datainfo.getEnabledDataModuleChoices()
                self.choiceModuleName.SetItems(choices)
                self.choiceModuleName.SetSelection(choices.index(selected))
            else:
                modulename = self.trace.modulename
                if modulename in choices:
                    self.choiceModuleName.SetSelection(choices.index(modulename))
                else:
                    modulename = choices[0]
                    self.choiceModuleName.SetSelection(0)
            self.OnChoiceModuleName()

    def OnEGData(self, event=None):
        egsel = EGSelectDlg.EGSelector()
        results = egsel.choiceModuleAndDiagname(self)
        if results is None:
            return
        modulename, diagname = results
        self.datainfo.datamodules.AddEnabledModules([modulename])
        self.datainfo.datamodules.EnabledModuleSave()
        choices = self.datainfo.getEnabledDataModuleChoices()
        self.choiceModuleName.SetItems(choices)
        self.choiceModuleName.SetSelection(choices.index(modulename))
        self.radioIDA.SetValue(True)
        self.tcIDA.Enable(True)
        self.tcIDR.Enable(False)
        self.tcIDC.Enable(False)
        self.btnIDA.Enable(True)
        self.tcIDA.SetValue(">%s@%%shot%%" % diagname)
        self.tcIDR.SetValue("%s" % self.graphinfo.dataid_ref)
        self.tcIDC.SetValue("%s" % self.graphinfo.dataid)
        #self.OnChoiceModuleName()
        self.ResetVars()

    def OnQuit(self, evt=None):
        self.Close()

    def WaitCursor(self, flg):
        if flg:
            self.mcursor = self.GetCursor()
            if wx.__version__ >= "4.0":
                waitcursor = wx.Cursor(wx.CURSOR_WAIT)
            else:
                waitcursor = wx.StockCursor(wx.CURSOR_WAIT)
            self.SetCursor(waitcursor)
        else:
            self.SetCursor(self.mcursor)

if __name__ == '__main__':
    app = wx.App()

    graphinfo = GraphInfo()
    graphinfo.load('plot_default.txt')
#    datainfo = DataInfo(graphinfo, 'DataModules/datamodules.txt', 'LabelModules/labelmodules.txt')
    datainfo = DataInfo(graphinfo, 'DataModules/datamodules.txt', 'DataModules/enabled.txt', 'LabelModules/labelmodules.txt')

    group = graphinfo.groups[0]
    panel = group.panels[0]
    trace = Trace(panel)
    trace.modulename = 'testdata'
    graphinfo.addTrace(trace)

    dialog = SetTraceDlg(None, trace, graphinfo, datainfo)
    result = dialog.ShowModal()
    if result == wx.ID_OK:
        dialogdata = dialog.GetResult()
        print(dialogdata)
    dialog.Destroy()


