#!/usr/bin/env python
# coding: utf-8
# $Id$

import wx
import wx.html
import os
import re
import sys
from MyViewGraphInfo import *
from MyViewDataInfo import *
from MyViewColorButton import *

if wx.__version__ < '3.0':
    wx.Color = wx.Colour

DefaultText = """
<p>Here is an expanation of this module <p><br>
Module name : modulename <br>
Script name : script.py <br>
Author name : the name of developer <br>
Contact to  : myview@project.jp <br>
<br>
<p>Options<p><br>
ntavg : average in time <br>
ex) ntavg=20 <br>
this means 20 data points in time are averaged and produces one data point.<br>
"""

def copydict(source):
    dist = {}
    for k, v in list(source.items()):
        dist[k] = v
    return dist


class SetTraceSymbolDlg(wx.Dialog):
    def __init__(self, parent, trace=None, graphinfo=None, colorpicker=None):
        wx.Dialog.__init__(self, parent, -1, 'MyView2 Setup Trace', 
                style=wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER |wx.STAY_ON_TOP)
       
        #self.SetBackgroundColour(wx.Colour(200, 200, 200))
        self.font = wx.Font(11, wx.MODERN, wx.NORMAL, wx.NORMAL, False)
        self.colorpicker = colorpicker

        self.parent = parent
        self.trace = trace
        self.graphinfo = graphinfo

        """
        do not change the values in self.panel and self.graphinfo inside this dialog
        after back to parent, the values in the panel should be changed if the dialog 
        return the wx.ID_OK.
        You can get the values in this dialog with calling dialog.getResult()  
        """

        stSymbol = wx.StaticText(self, -1, "Symbol: ")
        stSymbolSize = wx.StaticText(self, -1, "Size: ")
        stLineStyle = wx.StaticText(self, -1, "Style: ")
        stLineWidth = wx.StaticText(self, -1, "Width: ")
        stColor = wx.StaticText(self, -1, "Color: ")


        number_of_items = 5 
        self.comboSymbol = wx.ComboBox(self, -1, choices=[])
        self.comboSymbolSize = wx.ComboBox(self, -1, choices=[])
        self.comboLineStyle = wx.ComboBox(self, -1, choices=[])
        self.comboLineWidth = wx.ComboBox(self, -1, choices=[])
        self.color = "#%02X%02X%02X" % (255, 0, 0)
        self.btnColor = ColorButton(self, self.color, self.colorpicker)
       
        self.cbChecks = [] 
        for i in range(number_of_items):
            self.cbChecks.append(wx.CheckBox(self, -1, ''))

        fgsizer = wx.FlexGridSizer(rows=number_of_items, cols=3, hgap=5, vgap=5)
        fgsizer.AddGrowableCol(1)
        fgsizer.Add(self.cbChecks[0], 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stSymbol, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.comboSymbol, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        fgsizer.Add(self.cbChecks[1], 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stSymbolSize, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.comboSymbolSize, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        fgsizer.Add(self.cbChecks[2], 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stLineStyle, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.comboLineStyle, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        fgsizer.Add(self.cbChecks[3], 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stLineWidth, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.comboLineWidth, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        fgsizer.Add(self.cbChecks[4], 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(stColor, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)
        fgsizer.Add(self.btnColor, 1, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL)

        btnOk = wx.Button(self, wx.ID_OK, "OK")
        btnOk.SetDefault()
        btnCancel= wx.Button(self, wx.ID_CANCEL, "Cancel")
        btnsizer = wx.BoxSizer(wx.HORIZONTAL)
        btnsizer.Add(btnOk, 1, wx.EXPAND)
        btnsizer.Add(btnCancel, 1, wx.EXPAND)
        
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(fgsizer, 0, wx.EXPAND|wx.ALL)
        sizer.Add(btnsizer, 0, wx.EXPAND|wx.ALL, 5)
        
        self.SetSizer(sizer)
        self.Fit()

        self.Bind(wx.EVT_SIZE, self.OnResize, self)
        
        self.SetStateFirst()

    def SetStateFirst(self):
        """
        Setup the value of widgets on this dialog 
        by referencing with self.group and self.graphinfo.
        """
        #---------------------
        symbol = self.trace.symbol
        choices = SymbolSet
        self.comboSymbol.SetItems(choices)
        self.comboSymbol.SetValue(symbol)
        #---------------------
        symbolsize = self.trace.symbolsize
        choices = SymbolSizeSet
        self.comboSymbolSize.SetItems(choices)
        self.comboSymbolSize.SetValue(symbolsize)
        #---------------------
        linestyle = self.trace.linestyle
        choices = LineStyleSet
        self.comboLineStyle.SetItems(choices)
        self.comboLineStyle.SetValue(linestyle)
        #---------------------
        linewidth = self.trace.linewidth
        choices = LineWidthSet
        self.comboLineWidth.SetItems(choices)
        self.comboLineWidth.SetValue(linewidth)
        #---------------------
        self.color = self.trace.color
        self.btnColor.set_color(self.color)

    def OnResize(self, event):
        event.Skip()

    def OnColor(self, event=None):
        self.selCmapName.set_linecolor(event.color)

    def GetResult(self):
        symbol = self.comboSymbol.GetValue()
        symbolsize = self.comboSymbolSize.GetValue()
        linestyle = self.comboLineStyle.GetValue()
        linewidth = self.comboLineWidth.GetValue()
        color = self.btnColor.get_color()

        checks = [c.GetValue() for c in self.cbChecks]

        return ((symbol, symbolsize, linestyle, linewidth, color), checks)

    def OnQuit(self, evt=None):
        self.Close()

if __name__ == '__main__':
    from MyViewCache import *
    app = wx.App()

    graphinfo = GraphInfo()
    cache = MyViewCache('cache\cache.txt') 
    graphinfo.load('layout\plot_default.txt')
    graphinfo.args['cache'] = cache
    
    group = graphinfo.groups[0]
    panel = group.panels[0]
    trace = Trace(panel)
    trace.modulename = 'testdata'
    graphinfo.addTrace(trace)

    dialog = SetTraceSymbolDlg(None, trace, graphinfo)
    result = dialog.ShowModal()
    if result == wx.ID_OK:
        dialogdata = dialog.GetResult()
        print(dialogdata)
    dialog.Destroy()


