#!/usr/bin/env python
# coding: utf-8
# $Id$
import wx
import wx.lib.newevent
import os
import urllib.request, urllib.error, urllib.parse

DOWNLOAD_ONLY=0
DOWNLOAD_AND_UPDATE = 1

class MyViewUpdateDlg(wx.Dialog):
    def __init__(self, parent):
        wx.Dialog.__init__(self, parent, -1, 'Found Newer Version', size=(240, 200))
        btYes = wx.Button(self, -1 , "YES")
        btNo = wx.Button(self, wx.ID_NO , "NO")
        st_message=wx.StaticText(self, -1, "A newer version is available. \nDo you download it?")
        self.rb = wx.RadioBox(self, -1, "",choices=["Download Only","Download and Update"], style=wx.RA_VERTICAL)
        self.rb.SetSelection(1)
        st_message2=wx.StaticText(self, -1, "If you choose `update', \nmyView2 will end automatically.\nPlease restart it manually.")

        fgsizer = wx.FlexGridSizer(rows=6, cols=1, hgap=5, vgap=5)
        fgsizer.Add(st_message, wx.EXPAND)
        fgsizer.Add(wx.Size(10,10), 0, wx.EXPAND)
        fgsizer.Add(self.rb)
        hbox = wx.BoxSizer(wx.HORIZONTAL)

        fgsizer.Add(st_message2, wx.EXPAND)
        fgsizer.Add(wx.Size(10,10), 0, wx.EXPAND)

        hbox.Add(btYes)
        hbox.Add(btNo)
        fgsizer.Add(hbox, 0, wx.EXPAND)
        self.Bind(wx.EVT_BUTTON, self.OnYes, btYes)
        self.Bind(wx.EVT_BUTTON, self.OnNo, btNo)

        self.SetSizer(fgsizer)
        self.Fit()
        self.Layout()

    def GetSelection(self):
        return self.rb.GetSelection()

    def OnYes(self, event):
        self.EndModal(wx.ID_YES)
        self.Hide()

    def OnNo(self, event):
        self.EndModal(wx.ID_NO)
        self.Hide()
        
        
if __name__ == '__main__':
    app = wx.PySimpleApp()

    dialog = MyViewUpdateDlg(None)
    result = dialog.ShowModal()
    if ( result == wx.ID_YES ):
        print((dialog.GetSelection()))
    dialog.Destroy()

