#!/usr/bin/env python
import glob
import os
import zipfile
import re
import EGList
import sys
import shutil
import git
import getopt
import json
import MyViewProfile

PROFILES_DIR='profiles'


def usage(prog):
    keys = "|".join(PROFILES.keys())
    print("usage : %s [%s]" % (prog, keys))

def make_zip(root, base, filename, excludes=[]):
    if os.path.exists(filename):
        os.remove(filename)
    with zipfile.ZipFile(filename,'w') as zip:
        os.chdir(root)
        for dir_path, dir_names, file_names, in os.walk(base):
            zip.write(dir_path)
            for file_name in file_names:
                f = os.path.join(dir_path, file_name)
                skip = False
                for e in excludes:
                    if ( re.search(e, f) ):
                        skip=True
                        break
                if not skip and os.path.isfile(f) and os.access(f, os.R_OK):
                    zip.write(f)

try:
    opts, argv = getopt.getopt(sys.argv[1:], "hs",["help","skip-eglist"])
except getopt.GetoptError:
    pass

if len(argv) != 1:
    usage(sys.argv[0])
    exit(1)

skip = False
for o, a in opts:
    if o in  ('-h','--help'):
        usage(sys.argv[0])
        exit(1)
    elif o in ('-s', '--skip-eglist' ):
        skip = True

target=argv[0]

repo = git.Repo('.')
commits = list(repo.iter_commits())
with open('version.txt','w') as f:
    f.write("%d\n" % (len(commits)))

profile = MyViewProfile.Profile()
try:
    profile.update(target)
except:
    usage()
    exit(1)

try:    
    os.remove('temp/*')
except:
    pass
try:
    os.remove('cache/*')
except:
    pass


if ( skip ):
#    EGList.clear()
    pass
else:
    EGList.update()

os.chdir('..')
make_zip('.','myView2','myView2.zip',excludes = [r"\.svn", r"\.git",r"build/*"])

