#!/usr/bin/env python
# coding: utf-8
# $Id$

import socket
import timelimit
import time

HOST = 'egdb.lhd.nifs.ac.jp'   
PORT = 7878
class ShotNotifier():
    def __init__(self):
        pass
    
    def getCurrent(self):
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.connect((HOST, PORT))
        f = s.makefile()
        line = f.readline()
        (shotno, subno, seq) = line.split(',')
        s.close()
        shotno = int(shotno)
        subno = int(subno)
        seq = int(seq)
        if ( seq < 8 ):
            shotno = shotno -1
        return shotno

    def _getNext(self, currentShot):
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.connect((HOST, PORT))
        f = s.makefile()
        while True:
            line = f.readline()
            (shotno, subno, seq) = line.split(',')
            shotno = int(shotno)
            if ( shotno != currentShot ):
                break
        s.close()
        return shotno
    
    def getNext(self, currentShot, timeout):
        shotno = timelimit.timelimit(timeout, self._getNext, [currentShot])
        return shotno

# デバッグ用クラス
class ShotNotifier_d():
    def __init__(self):
        self.shot0 = 900000
        self.t0 = time.time()
        self.interval = 30
    
    def getCurrent(self):
        now = time.time()
        shotno = self.shot0 + int((now -self.t0)/self.interval)
        return shotno

    def _getNext(self, currentShot):
        while True:
            shotno = self.getCurrent()
            if ( shotno != currentShot ):
                break
            time.sleep(1)
        return shotno
    
    def getNext(self, currentShot, timeout):
        try:
            shotno = timelimit.timelimit(timeout, self._getNext, [currentShot])
        except:
            shotno = currentShot
        return shotno
        
if __name__ == '__main__':
    """
    notifier = ShotNotifier()
    shotNo = notifier.getCurrent()
    print shotNo
    nextNo = notifier.getNext(shotNo + 1, 10)
    print nextNo
    """
    notifier = ShotNotifier_d()
    shotNo = notifier.getCurrent()
    print(shotNo)
    nextNo = notifier.getNext(shotNo , 10)
    print(nextNo)


    
