#!/usr/bin/env python
# coding: utf-8
#

# レイアウトファイルにバージョン番号を追加する
# 利用法：
#    python convert_all.py レイアウトファイルのあるディレクトリ
#
import os
import sys
import re

reg_layout_file = re.compile('.*\.(txt|mvd)$',re.IGNORECASE)
reg_header = re.compile('layout_version\s+2')
reg_ver_line = re.compile('MyView2\[Ver\.%VERSION%\]')
reg_head_alabel = re.compile('^#cmd	name	idc	posx	posy	arg	family	style	weight	size	color	rotation	ha	va')
reg_date = re.compile('^alabel.*%year%/%month%/%day%')
line_date="alabel	shotinfo	C	0.98	0.97	%year%/%month%/%day%	sans-serif	normal	normal	large	#000000	0	right	center\n"
line_version="alabel	directtext	C	0.99	0.99	MyView2[Ver.%VERSION%] (%LAYOUT_FILE%)	sans-serif	normal	normal	small	#0000AA	0	right	center\n"

def convert_one(file):
    lines = open(file).readlines()
    m = re.match(reg_header, lines[0])
    if ( not m ):
        return

    tmpfile = file + '.tmp'
    oldfile = file + '.bak'
    tf = open(tmpfile,'w')
    for line in lines:
        if re.match(reg_date, line ):
            tf.write(line_date)
        else:
            tf.write(line)
        if re.match(reg_head_alabel, line ):
            tf.write(line_version)
    tf.close()
    os.rename(file,oldfile)
    os.rename(tmpfile, file)

def convert_all(dir):
    for root, dirs, files in os.walk(dir):
        for file in files :
            if ( reg_layout_file.search(file)):
                path = os.path.join(root,file)
                convert_one(path)

convert_all(sys.argv[1])


