#!/usr/bin/env python
# coding:shift_jis
# $Id$

import random
import numpy
import re
#import scipy.interpolate as intp

def random_str(length=20):
    ret = ""
    source = "abcdefghijklmnopqrstuvwxyz0123456789"
    source = source + source.upper()
    for i in range(length):
        ret += random.choice(source)
    return ret
    
def to_array(l):
    ret = []
    for e in l:
        if ( isinstance(e,list)):
            ret.append(numpy.array(e,dtype='float'))
        else:
            ret.append(e)
    return ret

def ReplaceKeywords(src, kwdic):
    """
    Replace keywords in the src with keyword dictionary(kwdic).
    """
    string = src[:]
    for key, value in list(kwdic.items()):
        string = string.replace(key, value)
    return string

def ReplaceShotnumberInFilename(filepath, shotno, subno, rshotno, rsubno):
    kwdic = {}
    if shotno is None:
        kwdic["%shot%"] = ""
        kwdic["%shot6%"] = ""
    else:
        if subno > 1:
            kwdic["%shot%"] = "%d_%d" % (shotno, subno)
            kwdic["%shot6%"] = "%06d_%d" % (shotno, subno)
        else:
            kwdic["%shot%"] = "%d" % shotno
            kwdic["%shot6%"] = "%06d" % shotno

    if rshotno is None:
        kwdic["%rshot%"] = ""
        kwdic["%rshot6%"] = ""
    else:
        if rsubno > 1:
            kwdic["%rshot%"] = "%d_%d" % (rshotno, rsubno)
            kwdic["%rshot6%"] = "%06d_%d" % (rshotno, rsubno)
        else:
            kwdic["%rshot%"] = "%d" % rshotno
            kwdic["%rshot6%"] = "%06d" % rshotno
    return ReplaceKeywords(filepath, kwdic)

shot_pat=re.compile(r'(\d+)_(\d+)')


def ParseShotNo(t):
    shotno=t
    subno=1
    m = shot_pat.match(shotno)
    try:
        if m :
            shotno=int(m[1])
            print('shotno=',shotno)
            subno=int(m[2])
        else:
            shotno = int(t)
    except ValueError:
        shotno = None
        subno = None
    return shotno, subno

def ShotStringToInteger(shot_str, rshot_str):
    shot, sub = ParseShotNo(shot_str)
    rshot, rsub = ParseShotNo(rshot_str)
    return shot, sub, rshot, rsub
    


    
