import wx
import wx.lib.newevent

import sys
import codecs
def cp65001(name):
    if name.lower() == 'cp65001':
        return codecs.lookup('utf-8')
codecs.register(cp65001)

if wx.__version__ >= '3.0.3':
    wx.OPEN = wx.FD_OPEN
    wx.SAVE = wx.FD_SAVE

    def AddSimpleToolToToolbar(toolbar, id_tool, icon, name, exp):
        tool = toolbar.AddTool(
                id_tool,  name, icon, exp, wx.ITEM_NORMAL)
        return tool
    
    wx.ToolBar.AddSimpleTool = AddSimpleToolToToolbar

    def InsertStringItemToList(lc, i, s):
        info = wx.ListItem()
        info.SetId(i)
        info.SetText(s)
        return lc.InsertItem(info)

    def SetStringItemToList(lc, index, c, s):
        info = wx.ListItem()
        info.SetId(index)
        info.SetColumn(c)
        info.SetText(s)
        lc.SetItem(info)

    wx.ListCtrl.InsertStringItem = InsertStringItemToList
    wx.ListCtrl.SetStringItem = SetStringItemToList

    class EmptyBitmap(wx.Bitmap):
        def __init__(self, *args, **kw):
            super(EmptyBitmap, self).__init__(*args, **kw)
    wx.EmptyBitmap = EmptyBitmap
    
    class EmptyImage(wx.Image):
        def __init__(self, *args, **kw):
            super(EmptyImage, self).__init__(*args, **kw)
    wx.EmptyImage = EmptyImage

    class BitmapFromImage(wx.Bitmap):
        def __init__(self, *args, **kw):
            super(BitmapFromImage, self).__init__(*args, **kw)
    wx.BitmapFromImage = BitmapFromImage

    def ImageFromBitmap(bmp):
        img = bmp.ConvertToImage()
        return img
    wx.ImageFromBitmap = ImageFromBitmap


    import wx.lib.agw.hyperlink
    class HyperlinkCtrl(wx.lib.agw.hyperlink.HyperLinkCtrl):
        def __init__(self, parent, wid, label, url):
            super(HyperlinkCtrl, self).__init__(parent, wid, 
                    label=label, URL=url)
    
    wx.HyperlinkCtrl = HyperlinkCtrl



