try:
    import matplotlib.backends.wx_compat as wxc
except:
    class wxc(object):
        is_phoenix = True
                                 
import matplotlib.backends.backend_wx
import wx
import os
from matplotlib import rcParams
from distutils.version import LooseVersion

def NewId():
    return wx.NewIdRef(count=1)

if wx.__version__ >= "4.0": 
    wx.NewId = NewId

def matplotlib_AddTool(parent, wx_ids, text, bmp, tooltip_text):
    if text in ['Pan', 'Zoom']:
        kind = wx.ITEM_CHECK
    else:
        kind = wx.ITEM_NORMAL
    if wxc.is_phoenix:
        add_tool = parent.AddTool
    else:
        add_tool = parent.DoAddTool

    if not wxc.is_phoenix or LooseVersion(wx.VERSION_STRING) >= "4.0.0b2":
        # NOTE: when support for Phoenix prior to 4.0.0b2 is dropped then
        # all that is needed is this clause, and the if and else clause can
        # be removed.
        kwargs = dict(label=text,
                      bitmap=bmp,
                      bmpDisabled=wx.NullBitmap,
                      shortHelp=text,
                      longHelp=tooltip_text,
                      kind=kind)
    else:
        kwargs = dict(label=text,
                      bitmap=bmp,
                      bmpDisabled=wx.NullBitmap,
                      shortHelpString=text,
                      longHelpString=tooltip_text,
                      kind=kind)

    return add_tool(wx_ids[text], **kwargs)

def NavigationToolbar2Wx_init_toolbar(self):
    #DEBUG_MSG("_init_toolbar", 1, self)

    self._parent = self.canvas.GetParent()

    self.wx_ids = {}
    for text, tooltip_text, image_file, callback in self.toolitems:
        if text is None:
            self.AddSeparator()
            continue
        self.wx_ids[text] = wx.NewId()
        #wxc._AddTool(self, self.wx_ids, text,
        #            _load_bitmap(image_file + '.png'),
        #            tooltip_text)
        matplotlib_AddTool(self, self.wx_ids, text,
                    matplotlib.backends.backend_wx._load_bitmap(image_file + '.png'),
                    tooltip_text)

        self.Bind(wx.EVT_TOOL, getattr(self, callback),
                  id=self.wx_ids[text])

    self.Realize()

