import wx
import wx.lib.newevent

if wx.__version__ >= '3.0.3':
    wx.OPEN = wx.FD_OPEN
    wx.SAVE = wx.FD_SAVE

    def AddSimpleToolToToolbar(toolbar, id_tool, icon, name, exp):
        tool = toolbar.AddTool(
                id_tool,  name, icon, exp, wx.ITEM_NORMAL)
        return tool
    
    wx.ToolBar.AddSimpleTool = AddSimpleToolToToolbar

    def InsertStringItemToList(lc, i, s):
        info = wx.ListItem()
        info.SetId(i)
        info.SetText(s)
        return lc.InsertItem(info)

    def SetStringItemToList(lc, index, c, s):
        info = wx.ListItem()
        info.SetId(index)
        info.SetColumn(c)
        info.SetText(s)
        lc.SetItem(info)

    wx.ListCtrl.InsertStringItem = InsertStringItemToList
    wx.ListCtrl.SetStringItem = SetStringItemToList

    class EmptyBitmap(wx.Bitmap):
        def __init__(self, *args, **kw):
            super(EmptyBitmap, self).__init__(*args, **kw)

    wx.EmptyBitmap = EmptyBitmap

    import wx.lib.agw.hyperlink
    class HyperlinkCtrl(wx.lib.agw.hyperlink.HyperLinkCtrl):
        def __init__(self, parent, wid, label, url):
            super(HyperlinkCtrl, self).__init__(parent, wid, 
                    label=label, URL=url)
    
    wx.HyperlinkCtrl = HyperlinkCtrl
    wx.THICK_FRAME = 64



